/*****************************************************************************/
/* convertPEP.h                                 (c) Stefan Roemer 1993-1998  */
/*                                              Version h-1.5.2 (04.03.1998) */
/*****************************************************************************/
/* Schnittstellen-Bibliothek zum Lesen (Schreiben) des PEP-Netzdateiformats  */
/* in die (aus den) grundlegenden Datenstrukturen fuer Petri-Netze.          */
/*****************************************************************************/
/*                                    Stefan Roemer,  13.12.1993-04.03.1998  */
/*****************************************************************************/
/*                                                                           */
/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*                                                                           */
/* ACHTUNG: Diese Datei enthaelt elementare Routinen, die von vielen ver-    */
/* schiedenen Programmen benoetigt werden.                                   */
/* Jede beabsichtigte Aenderung am Programmcode sowie das Kopieren von       */
/* Programmteilen deshalb bitte unverzueglich an mich senden. Danke.         */
/* E-mail: roemer@informatik.tu-muenchen.de                                  */
/*                                                                           */
/* !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!! */
/*                                                                           */
/*****************************************************************************/
	
#ifndef __CONVERTPEP_H__	
#define __CONVERTPEP_H__	
	
#include "neunetze.h"	
	
	
/*****************************************************************************/

#define Co(X)		(Coords) (X)->inscript
#define GET_PL_X_POS( PL )      ( ( ( Co(PL) )->x ) )
#define GET_PL_Y_POS( PL )      ( ( ( Co(PL) )->y ) )
#define GET_PL_MEAN_X_REL( PL ) ( ( ( Co(PL) )->next->x ) )
#define GET_PL_MEAN_Y_REL( PL ) ( ( ( Co(PL) )->next->y ) )
#define GET_PL_MEANING( PL )    ( (char *) ( ( Co(PL) )->next->next->x ) )
#define GET_PL_REFERENCE( PL )  ( (char *) ( ( Co(PL) )->next->next->y ) )
#define GET_PL_TYPE( PL ) ( (char *) ( ( Co(PL) )->next->next->next->x ) )
#define GET_PL_IMARK_STR( PL ) \
                        ( (char *) ( ( Co(PL) )->next->next->next->y ) )
#define GET_PL_CMARKS( PL ) \
                             ( ( ( Co(PL) )->next->next->next->next->y ) )

#define SET_PL_X_POS( PL, NUM )      ( ( ( Co(PL) )->x ) = (NUM) )
#define SET_PL_Y_POS( PL, NUM )      ( ( ( Co(PL) )->y ) = (NUM) )
#define SET_PL_MEAN_X_REL( PL, NUM ) ( ( ( Co(PL) )->next->x ) = (NUM) )
#define SET_PL_MEAN_Y_REL( PL, NUM ) ( ( ( Co(PL) )->next->y ) = (NUM) )
#define SET_PL_MEANING( PL, STR ) \
                   ( ( ( Co(PL))->next->next->x ) = (int) Strdup(STR) )
#define SET_PL_REFERENCE( PL, STR ) \
                   ( ( ( Co(PL) )->next->next->y ) = (int) Strdup(STR) )
#define SET_PL_TYPE( PL, STR ) \
             ( ( ( Co(PL) )->next->next->next->x ) = (int) Strdup(STR) )
#define SET_PL_IMARK_STR( PL, STR ) \
             ( ( ( Co(PL) )->next->next->next->y ) = (int) Strdup(STR) )
#define SET_PL_CMARKS( PL, NUM ) \
                   ( ( ( Co(PL) )->next->next->next->next->y ) = (NUM) )

#define FREE_PL_MEANING( PL ) \
                      ( Free( (void *) ( ( Co(PL) )->next->next->x ) ) )
#define FREE_PL_REFERENCE( PL ) \
                      ( Free( (void *) ( ( Co(PL) )->next->next->y ) ) )
#define FREE_PL_TYPE( PL ) \
                ( Free( (void *) ( ( Co(PL) )->next->next->next->x ) ) )
#define FREE_PL_IMARK_STR( PL ) \
                ( Free( (void *) ( ( Co(PL) )->next->next->next->y ) ) )

#define GET_TR_X_POS( TR )       ( ( ( Co(TR) )->x ) )
#define GET_TR_Y_POS( TR )       ( ( ( Co(TR) )->y ) )
#define GET_TR_MEAN_X_REL( TR )  ( ( ( Co(TR) )->next->x ) )
#define GET_TR_MEAN_Y_REL( TR )  ( ( ( Co(TR) )->next->y ) )
#define GET_TR_ACTION_TERM( TR ) \
                              ( (char *) ( ( Co(TR) )->next->next->x ) )
#define GET_TR_MEANING( TR ) \
                              ( (char *) ( ( Co(TR) )->next->next->y ) )
#define GET_TR_VALUE_TERM( TR ) \
                        ( (char *) ( ( Co(TR) )->next->next->next->x ) )
#define GET_TR_ANNOTATION( TR ) \
                        ( (char *) ( ( Co(TR) )->next->next->next->x ) )
#define GET_TR_REFERENCE( TR ) \
                        ( (char *) ( ( Co(TR) )->next->next->next->y ) )

#define SET_TR_X_POS( TR, NUM )       ( ( ( Co(TR) )->x ) = (NUM) )
#define SET_TR_Y_POS( TR, NUM )       ( ( ( Co(TR) )->y ) = (NUM) )
#define SET_TR_MEAN_X_REL( TR, NUM ) \
                                     ( ( ( Co(TR) )->next->x ) = (NUM) )
#define SET_TR_MEAN_Y_REL( TR, NUM ) \
                                     ( ( ( Co(TR) )->next->y ) = (NUM) )
#define SET_TR_ACTION_TERM( TR, STR ) \
                   ( ( ( Co(TR) )->next->next->x ) = (int) Strdup(STR) )
#define SET_TR_MEANING( TR, STR ) \
                   ( ( ( Co(TR) )->next->next->y ) = (int) Strdup(STR) )
#define SET_TR_VALUE_TERM( TR, STR ) \
             ( ( ( Co(TR) )->next->next->next->x ) = (int) Strdup(STR) )
#define SET_TR_ANNOTATION( TR, STR ) \
             ( ( ( Co(TR) )->next->next->next->x ) = (int) Strdup(STR) )
#define SET_TR_REFERENCE( TR, STR ) \
             ( ( ( Co(TR) )->next->next->next->y ) = (int) Strdup(STR) )

#define FREE_TR_ACTION_TERM( TR ) \
                      ( Free( (void *) ( ( Co(TR) )->next->next->x ) ) )
#define FREE_TR_MEANING( TR ) \
                      ( Free( (void *) ( ( Co(TR) )->next->next->y ) ) )
#define FREE_TR_VALUE_TERM( TR ) \
                ( Free( (void *) ( ( Co(TR) )->next->next->next->x ) ) )
#define FREE_TR_ANNOTATION( TR ) \
                ( Free( (void *) ( ( Co(TR) )->next->next->next->x ) ) )
#define FREE_TR_REFERENCE( TR ) \
                ( Free( (void *) ( ( Co(TR) )->next->next->next->y ) ) )


/*****************************************************************************/
	
typedef struct plist_	
  {	
    Place         item;	
    struct plist_ * next;	
  } P_LIST_ELEM,	
    * P_LIST;	
	
typedef struct mlist_	
  {	
    char          * meaning;	
    P_LIST        list;	
    Cardinal32    number;	
    struct mlist_ * next;	
  } M_LIST_ELEM,	
    * M_LIST;	
	
typedef struct coords_	
  {	
    int            x,	
                   y;	
    struct coords_ * next;	
  } CoordEntry,	
    * Coords;	
	
	
/*****************************************************************************/
	
extern char       CM_nettype[];	
extern bool       CM_storeMeaning,	
                  CM_storeCoordinates,	
                  CM_storeReferences,	
                  CM_use_imarks;	
extern M_LIST     CM_placeMList,	
                  CM_transMList;	
extern Cardinal32 CM_countMPlaces,	
                  CM_countPMeanings,	
                  CM_countMTransitions,	
                  CM_countTMeanings;	
	
	
/*****************************************************************************/
	
#if defined(__STDC__) || defined(__cplusplus)	
extern void delete_meaning_list( M_LIST );	
#else	
extern void delete_meaning_list( /* M_LIST list */ );	
#endif	
  /* entfernt eine 'meaning-list' aus dem Speicher.                          */
	
/*****************************************************************************/
	
#if defined(__STDC__) || defined(__cplusplus)	
extern LMPNet read_PEP( char * );	
#else	
extern LMPNet read_PEP( /* char * PEPfilename */ );	
#endif	
  /* liefert einen Pointer auf eine Matrix, in der das Netz gespeichert ist. */
  /* Ergebnis ist NULL-Pointer, wenn eine entsprechend benannte PEP-Datei   */
  /* nicht existiert.                                                        */
	
/*****************************************************************************/
	
#if defined(__STDC__) || defined(__cplusplus)	
extern void write_PEP( LMPNet, char * );	
#else	
extern void write_PEP( /* LMPNet net, char * filename */ );	
#endif	
  /* Gibt die mit net bezeichnete Matrix als Inzidenzmatrix nach 'filename'  */
  /* aus.                                                                    */
  /* NOCH NICHT IMPLEMENTIERT !!! */
	
/*****************************************************************************/
	
#if defined(__STDC__) || defined(__cplusplus)	
extern LMPNet read_new_PEP( char * );	
#else	
extern LMPNet read_new_PEP( /* char * PEPfilename */ );	
#endif	
  /* Liefert einen Pointer auf eine Matrix, in der das Netz gespeichert ist. */
  /* Ergebnis ist NULL-Pointer, wenn eine entsprechend benannte PEP-Datei    */
  /* nicht existiert.                                                        */
  /* Es wird das neue PEP-Dateiformat erwartet.                              */
	
/*****************************************************************************/
	
#if defined(__STDC__) || defined(__cplusplus)	
extern void write_new_PEP( LMPNet, char * );	
#else	
extern void write_new_PEP( /* LMPNet net, char * filename */ );	
#endif	
  /* Gibt die mit net bezeichnete Matrix als Inzidenzmatrix nach 'filename'  */
  /* aus. Verwendet das neue PEP-Netzdateiformat.                            */
	
/*****************************************************************************/
	
#if defined(__STDC__) || defined(__cplusplus)	
extern void write_new_Tobi( LMPNet, char * );	
#else	
extern void write_new_Tobi( /* LMPNet net, char * filename */ );	
#endif	
  /* Gibt die mit net bezeichnete Matrix als Inzidenzmatrix nach 'filename'  */
  /* aus. Verwendet das Netzdateiformat von Tobias Himstedt (HL-Netze).      */
	
/*****************************************************************************/
	
#if defined(__STDC__) || defined(__cplusplus)	
extern LMPNet read_STG( char * );	
#else	
extern LMPNet read_STG();	
#endif	
	
/*****************************************************************************/
	
#if defined(__STDC__) || defined(__cplusplus)	
extern void write_STG( LMPNet, char * );	
#else	
extern void write_STG();	
#endif	
	
/*****************************************************************************/
	
#if defined(__STDC__) || defined(__cplusplus)	
extern LMPNet read_FSA( char * );	
#else	
extern LMPNet read_FSA();	
#endif	
	
/*****************************************************************************/
	
#if defined(__STDC__) || defined(__cplusplus)	
extern void write_FSA( LMPNet, char * );	
#else	
extern void write_FSA();	
#endif	
	
/*****************************************************************************/
	
#endif /* __CONVERTPEP_H__ */
	
	
/*****************************************************************************/
/* END OF FILE convertPEP.h                                                  */
/*****************************************************************************/
	
