/**********************************/
/* function.h                     */
/* Burkhard Graves, 06.10.93      */
/* Lars Jenner, Juni 1994         */
/**********************************/

#ifndef __FUNCTION_H__
#define __FUNCTION_H__

#include <stdlib.h>

/**********************************/
/* Globale Defines                */
/**********************************/

#if 1
#define PROTO(x) x
#else
#define PROTO(x) ()
#endif

#define _I 0
#define _W 1
#define _E 2
#define _F 3

/**********************************/
/* Globale Typdefinitionen        */
/**********************************/

typedef short int Integer; /* auf der SUN: 16-Bit-Wert */

typedef unsigned short int Cardinal; /* auf der SUN: 16-Bit-Wert */

/* Formatstring des eben definierten Typs fuer die Ausgabe mit 'printf()'    */
#define FORMAT_CARD "%hu"

typedef unsigned int Cardinal32; /* auf der SUN: 32-Bit-Wert */


/**********************************/
/* Globale Funktionen             */
/**********************************/

#ifdef __cplusplus
extern void Msg( char Type, ... );
#else
#if defined (sun) || defined (linux)
extern void Msg();
#else
extern void Msg( ... );
#endif
#endif

void  *MYmalloc PROTO ((size_t size));
void *MYrealloc PROTO ((void *ptr, size_t size));
char  *MYstrdup PROTO ((char *str));
int      MYfree PROTO ((void *ptr));

/*****************************************************************************/
/* Makros zur Bestimmung von Minimum bzw. Maximum zweier beliebiger, jedoch  */
/* vergleichbarer Werte irgendeines Aufzaehltyps.                            */
/*****************************************************************************/

#define Min( a, b ) ( (a) < (b) ? (a) : (b) )

#define Max( a, b ) ( (a) > (b) ? (a) : (b) )


/*****************************************************************************/
/* Ausgabe der allgemeinen Fehlermeldung `msg`; fuehrt zum Programmabbruch.  */
/*****************************************************************************/

#if defined(__STDC__) || defined(__cplusplus)

extern void Error( char * msg );

#else

extern void Error( /* char * msg */ );

#endif


/*********************************/
/* END OF FILE function.h        */
/*********************************/

#endif /* __FUNCTION_H__ */

