/*****************************************************************************/
/* main.h                                                                    */
/*****************************************************************************/


#ifndef __MAIN_H__
#define __MAIN_H__


/*****************************************************************************/

#include <stdio.h>
#include "function.h"


/*****************************************************************************/
/*                 Allgemeine Typdefinitionen und Konstanten                 */
/*****************************************************************************/

#define OUT_OWN         1
#define OUT_PEP         2
#define EXPL_FREE	4
#define CHECK_NET       8
#define REMOVE_DUPL    16
#define BUNDLE         32
#define PAR_TERM       64
#define EXT_LABEL     128
#define BIG_LOOP      256
#define MEDIUM_LOOP   512
#define BPN_NAMES    1024
#define NO_SCOPING   2048

extern Cardinal flag,scale;
extern char *own_file,*pep_file;


/*****************************************************************************/
/* Defines fuer das Ausgabeformat.                                           */
/*****************************************************************************/

#define marke 		"dot"	/* Annotation fuer Eingaenge & Ausgaenge */
#define exit_postfix	"@e"	/* Postfix fuer die Exit-Aktion */
#define and_sym		" & "	/* Symbol fuer logisches AND */

extern Cardinal var_style;	/* Ausgabestyle fuer Kommunikationsvariablen */

#define VAR_BOTH	0	/* real_name UND com_nr ausgeben */
#define VAR_COM		1	/* nur com_nr ausgeben */
#define VAR_REAL	2	/* nur real_name ausgeben */


/*****************************************************************************/
/* Globale Datenstrukturen.                                                  */
/*****************************************************************************/

extern FILE *yyin,*yyout;
extern int sozei;
extern int dinit;
extern int sterm;

#if !defined (sun) && !defined (linux)
extern unsigned long PreMem;
#endif

/*****************************************************************************/
/* Leeranweisung fuer leere Schleifenruempfe                                 */
/*****************************************************************************/

#define skip


/*****************************************************************************/
/* Datentyp fuer Boole'sche Ausdruecke                                       */
/*****************************************************************************/

typedef unsigned char Boolean;
#define False 0
#define True 1


/*****************************************************************************/
/* HL-Action-Struktur                                                        */
/*****************************************************************************/

typedef Cardinal ComVar;


/*****************************************************************************/
/* Datentyp zur internen Darstellung von Aktion(snam)en und Variablen(namen) */
/*****************************************************************************/
 
typedef Cardinal Action,
                 Var,
                 Func;


/*****************************************************************************/
/* Datentyp zur Repraesentation von Multimengen und Abbildungslisten.        */
/*****************************************************************************/

typedef Action * MultiSet;
typedef MultiSet Function;


/*****************************************************************************/
/* Variable-Struktur                                                         */
/*****************************************************************************/

/*
typedef struct Variable_
{ ComVar	nr;
  Cardinal	anzahl;
} Variable, *VarMSet;
*/

typedef char * VarMSet;


/*****************************************************************************/
/* Datentyp zur Repraesentation von Multimengen:                             */
/*****************************************************************************/

typedef Cardinal FuncCode;


/*****************************************************************************/
/* Darstellung einer Multimenge bei der Ausgabe.                             */
/*****************************************************************************/

extern Boolean MSdisplay_style; /* globale Variable */

#define MS_WIDE False
#define MS_SHORT True


/*****************************************************************************/
/* Maximal vorgesehene Anzahl von Aktionsnamen in Symboltabelle; wird        */
/* dynamisch an die tatsaechlich benoetigte Groesse angepasst!               */
/*****************************************************************************/

#define ACTION_BUF_SIZE 100


/*****************************************************************************/
/* Datentyp Symboltabelle fuer die Aktions-/Variablennamen ( Parser ).       */
/*****************************************************************************/

typedef char        * SymTabEntry;
typedef SymTabEntry * SymTab;
typedef Function    * MapTab;

extern SymTab ActSymTable;
extern SymTab VarSymTable;
extern SymTab FuncSymTable;
extern MapTab FuncMapTable;


/*****************************************************************************/

#endif /* __MAIN_H__ */

/*****************************************************************************/
/* END OF FILE main.h                                                        */
/*****************************************************************************/

