/*********************************/
/* mylib.c                       */
/* Frank Wallner       14.8.96   */
/*********************************/

#include "qq_header.h"

/********************************/
/* Functions                    */
/********************************/

int  myindex(char *s, char *t)
{
	register int i=0, j=0, k=0;

	if ( s == (char *) NULL) return(-1);
	for (i=0; s[i] != '\0'; i++) {
		for (j=i, k=0; t[k] != '\0' && s[j] == t[k]; j++, k++) ;
		if (t[k] == '\0') return(i);
		}
	return(-1);
}
/*----------------------------------------------------------------------*/
void mystr2int(char s[], int *i)
{
	register int j=0, k=0;

	*i=0;
	while (s[k] == ' ') k++; 
	for (j=k; s[j] >='0' && s[j] <= '9'; j++){
		*i = 10 * (*i) + s[j] - '0';
		}
}
/*----------------------------------------------------------------------*/
void myTN2int(char s[], int *i)
{
	register int j=0, k=0;

	*i=0;
	while ( (s[k] == 'T') || 
                (s[k] == '_') ||
                (s[k] == 'c') ) k++; 
	for (j=k; s[j] >='0' && s[j] <= '9'; j++){
		*i = 10 * (*i) + s[j] - '0';
		}

}
/*----------------------------------------------------------------------*/
void myint2str(int i, char s[])
{
	register int j, k=0;
        char t[12];

        /*k=0; */
        while ( i ) {
              t[k++] = (char) ('0' + (j=(i%10)));
              i = (i-j)/10;
              }
        s[k] = t[k--] = '\0';
        j = k;
        while (j>=0) s[k-j] = t[j--];

}
/*----------------------------------------------------------------------*/
void paste(int start, int end, char s[], char t[])
{
	int i = 0;

	end--;
	while (end-- && s[start]!='\n') t[i++] = s[start++];
	t[i]='\0';
}
/*----------------------------------------------------------------------*/
void *MyMalloc(int size)
{
	register char *c;

	if ( ! (c = calloc(size, 1) ) ) {
		printf("\nMalloc() failed!\n\n");
		exit(1);
		}
	return(c);
}
/*----------------------------------------------------------------------*/

/************************************************************************/
/* Diese Funktionen werden zur genauen Zeitmessung verwendet. Zeitmessung */
/* mit time() hat den Nachteil, dass es nur sekundengenau arbeiten kann,  */
/* waehrend clock() keine Zeiten von mehr als (etwa) einer halben Stunde  */
/* messen kann. nc_startclock merkt sich beide Werte, nc_stopclock stellt */
/* fest, welcher Wert zurueckgegeben werden sollte. nc_stopclock gibt den */
/* Speicher wieder frei, den nc_startclock belegt hat.			  */

etime_t nc_startclock()
{
	etime_t et = MyMalloc(sizeof(etime_instance));
	et->clock = clock();
	et->time = time(NULL);
	return et;
}

float nc_stopclock(etime_t et)
{
	float ntime, nclock;

	nclock = clock() - et->clock;
	ntime = time(NULL) - et->time;
	free(et);
	return (ntime > 2000)? ntime : (nclock/CLOCKS_PER_SEC);
}


/*---------------------------------------------------------------FIN--*/
