/*********************************/
/* outputs.c                     */
/* Frank Wallner       14.8.96   */
/*********************************/

#include "qq_header.h"

/**************************************************************************/
void PrintTS_Simple(FILE *f, ConfS cutoffconfig, ConfS corrconfig)
{
	int   i=1,w,bit;
	ElemS x;

	x = corrconfig[0] & ~bitmask[0];
	if (x!=0) {
	      w = 0;
	      for ( bit=0; bit<BA_BASE; bit++, w++ ) { 
		  if (x < bitmask[bit]) continue;
		  x -= bitmask[bit];
		  fprintf(f,"%s,",TransName(w)); 
		  if (x == 0) break; }
              }
	while ( (x=corrconfig[i++]) != BA_ALL) {
	      if (x==0) continue;
	      w = BA_BASE*(i-1);
	      for ( bit=0; bit<BA_BASE; bit++, w++ ) { 
		  if (x < bitmask[bit]) continue;
		  x -= bitmask[bit];
		  fprintf(f, "%s,",TransName(w)); 
		  if (x==0) break; }
              }
	fprintf(f, "\n("); i=0;
	Setminus(cutoffconfig, corrconfig, conf1);
	while ( (x=conf1[i++]) != BA_ALL) {
	      if (x==0) continue;
	      w = BA_BASE * (i-1);
	      for ( bit=0; bit<BA_BASE; bit++, w++ ) { 
		  if (x < bitmask[bit]) continue;
		  x -= bitmask[bit];
		  fprintf(f, "%s,",TransName(w)); 
		  if (x==0) break;}
              }
        fprintf(f, ")\n----------------------------------------------\n");
}
/**************************************************************************/
void PrintConfig(FILE *f, ConfS conf, int transnums)
/* transnums = 0 : E1,B2,E9,F12,....
   transnums = 1 : E1,E2,E9,E12,....,CUT_E109,
   transnums = 2 : E1(T4),E2(_c_T1),E9(T12),E12*(_c_T2),...
   transnums = 3 : T4,_c_T1,T12,_c_T2,...
   transnums = 4 : T4,T12,....
   transnums = 9 : (print Cuts!) B123,B124,B340,B345,...               */
{
	register int   	bit, w, i=0;
	int 		tabulator=0;
	char 		c;
 	ElemS   	x;

	while ( (x=conf[i]) != BA_ALL) {
	    if (x == 0) { i++; continue; }
	    w = BA_BASE*(i++);
	    for ( bit=0; bit<BA_BASE; bit++, w++ ) {
		if (x < bitmask[bit]) continue;
		x -= bitmask[bit];
		if (w == 0) continue;
		if (transnums==9) c = 'B';
                else              c = 'E';
		if (transnums==0) {
                           if (IS(BUECHI,w)) c = 'B';
		           if (IS(FINAL,w))  c = 'F';}
                if (transnums==1 && IS(CUTOFF,w)) fprintf(f,"CUT_");
                if (transnums != 3 && transnums != 4)
		           fprintf(f,"%c%d", c, w);
                if (transnums==2 && IS(FINAL,w)) fprintf(f,"*");
                if (transnums==2) fprintf(f,"(");
                if (transnums==2 || transnums==3)
                           fprintf(f,"%s", TransName(w));
                if (transnums==4 && !IS(BUECHI,w))
                           fprintf(f,"%s,", TransName(w));
                if (transnums==2) fprintf(f,")");
                if (transnums != 4) fprintf(f,","); tabulator++;
		if (tabulator>=16){fprintf(f,"\n");tabulator=0;}
		if (x == 0) break;
	        }
	    }
	fprintf(f,"\n");
}
/*********************************************************************/
void PrintConf_TN(FILE *f, ConfS conf)
{
	register int   	bit, w = -1, i = 1;
	int 		tabulator = 0;
 	ElemS   	x;

	x = conf[0] & ~bitmask[0];
        if ( x != 0 )
	    for (bit=0; bit<BA_BASE; bit++){
		w++; 
		if ( x < bitmask[bit] ) continue;
		x -= bitmask[bit];
                fprintf(f,"%s,", TransName(w));
                tabulator++;
		if ( x == 0 ) break;
	        }

	while ( (x=conf[i]) != BA_ALL ) {
	    if (x == 0) { i++; continue; }
	    w = BA_BASE*(i++);
	    for ( bit=0; bit<BA_BASE; bit++, w++ ) {
		if ( x < bitmask[bit] ) continue;
		x -= bitmask[bit];
                fprintf(f,"%s,", TransName(w));
                tabulator++;
		if ( tabulator>=12 ) { fprintf(f,"\n"); tabulator = 0; }
		if ( x == 0 ) break;
	        }
	    }
}
/*********************************************************************/
void fpConfTN(FILE *f, ConfS conf, int *tab)
{
	register int   	bit, w, i = 0;
 	ElemS  		x;

	while ( (x=conf[i]) != BA_ALL ) {
	    if (x == 0) { i++; continue; }
	    w = BA_BASE*(i++);
	    for ( bit=0; bit<BA_BASE; bit++, w++ ) {
		if ( x < bitmask[bit] ) continue;
		x -= bitmask[bit];
                fprintf(f,"%s,", TransName(w));
                (*tab)++;
		if ( *tab >= 12 ) { fprintf(f,"\n"); *tab = 0; }
		if ( x == 0 ) break;
	        }
	    }
}
/**************************************************************************/
void PrintTransSeq(FILE *f, int *path, int from, int to)
{
	int i=0, *tabulator, e1, e2 , ee1, ee2;
	Edge *nedge;
 	ConfS c1, c2;
      
	tabulator = (int *) MyMalloc(sizeof(int));
        *tabulator = 0;
	if ( IS (CUTOFF, from) ) 
	     PrintConf_TN( f, config( correspond(from) ) ); 
	else PrintConf_TN( f, config(from) ); 
	fprintf(f,"\n\n(");
 	e2 = from;
	e1 = to;
        while (1) {
            if ( IS(CUTOFF,e2) ) c2 = config( correspond(e2) );
	    else c2 = config(e2);
	    ee2 = from;
            if (e1 != from) {
                while ( path[scc_idx(ee2)] != e1 ) { 
                    ee1 = path[scc_idx(ee2)]; 
 		    ee2 = ee1;
		    }
                }
            /* next edge to print is [n]\[cor(e2)] */
 	    if (IS(CUTOFF, e2)) nedge = adjacents(e2);
	    else nedge = __adjacents(e2);
	    while ( nedge ) {
 	        if ( nedge->adj != e1 ) { nedge = nedge->next; continue; }
                c1 = config(nedge->n); 
		if ( F_0_(nedge->final) ) { Setminus(c1, c2, conf2); break; }
		if ( F_1_(nedge->final) ) { Setminus(c2, c1, conf2); break; }
                }
            if ( ! nedge ) { printf("\nOHA(2)\n"); exit(1); }
	    fpConfTN(f, conf2, tabulator);
            e2 = e1; 
 	    e1 = ee2; 
            if ( e2 == from ) break; 
            }	
	fprintf(f, ")\n");
        free(tabulator);
}
/**************************************************************************/
void X_PrintTransSeq(FILE *f, int *path, int from, int to)
{
	int i=0, *tabulator, e1, e2 , ee1, ee2, p_2;
	Edge *nedge;
	ENode *en;
	ENCorr *encorr;
 	ConfS c1, c2;
      
	tabulator = (int *) MyMalloc(sizeof(int));
        *tabulator = 0;
	/*
	fprintf(f,"\n%d", from);
	if (from < 0) { fprintf(f, " (%d) ", search_enod(from)->final); }
	fprintf(f,"\n");
	*/

	/*** print initial Transition-Sequence ***/
	if ( from > 0 ) {
	     if ( IS (CUTOFF, from) ) {
	            PrintConf_TN( f, config( correspond(from) ) ); }
	     else { PrintConf_TN( f, config(from) ); }
	     }
        else { en = search_enod(from);
	       if ( EN_IS(LOCAL, en) ) {
		      c1 = config( (int) en->corr);
		      /*
	              fprintf(f, "\n");
	              PrintConfig(c1, f, 2);
	              fprintf(f, "\n");
		      */
		      PrintConf_TN(f, config( (int) en->corr ));
		      }
	       else { encorr = en->corr;
		      IL2CONF(encorr->conf, conf4, ba_idx(encorr->max->i) );
		      /*
	              fprintf(f, "\n");
	              PrintConfig(f, conf4, 2);
	              fprintf(f, "\n");
		      */
		      PrintConf_TN(f, conf4); }
             }

	/*** print Loop ***/
	fprintf(f,"\n\n(");
 	e2 = from;
	e1 = to;
        while ( 1 ) {
	    if ( e2 >= 0 ) {
                   if ( IS(CUTOFF,e2) ) 
			c2 = config( correspond(e2) );
	           else c2 = config(e2); }
            else { if ( EN_IS(LOCAL, search_enod(e2)) ) 
			  c2 = config( (int) (search_enod(e2))->corr );
                   else { encorr = search_enod( (e2) )->corr;
			  IL2CONF(encorr->conf,conf1,ba_idx(encorr->max->i));
                          c2 = conf1; }
                 }
	    ee2 = from;
            if (e1 != from) {
		if ( ee2 >= 0 ) p_2 = path[scc_idx(ee2)];
		else p_2 = path[EN_scc_idx(search_enod(ee2))];
                while ( p_2 != e1 ) { 
                    ee1 = p_2; 
 		    ee2 = ee1;
		    if ( ee2 >= 0 ) p_2 = path[scc_idx(ee2)];
		    else p_2 = path[EN_scc_idx(search_enod(ee2))];
		    }
                }
            /*** detected: e2 --> e1 ***/
	    /*
	    fprintf(f, "\n %d ", e2);
	    if (e2>0 && IS(CUTOFF,e2)) fprintf(f,"(%d)", correspond(e2));
	    if (e2 < 0) { fprintf(f,"[%d]\n", (search_enod(e2))->cutoff);
			  Print_ENCorr_Info(f, search_enod(e2)); }
	    fprintf(f," --> %d ", e1);
	    if (e1>0 && IS(CUTOFF,e1)) fprintf(f,"(%d)", correspond(e1));
	    if (e1 < 0) { fprintf(f,"[%d]\n", (search_enod(e1))->cutoff);
			  Print_ENCorr_Info(f, search_enod(e1)); }
	    fprintf(f, "\n");
	    */

            /* next edge to print is [n]\[cor(e2)] */
	    if ( e1 >= 0 ) {
	       if ( e2 >= 0 ) {
		    if ( IS(CUTOFF, e2) ) 
			 nedge = adjacents(e2);
		    else nedge = __adjacents(e2); }
               else { if ( EN_IS(LOCAL, search_enod(e2)) )
			     nedge = __adjacents((int) (search_enod(e2))->corr );
			else nedge = (search_enod(e2))->corr->adjs;
		    }
	       while ( nedge ) {
 	             if ( nedge->adj != e1 ) { nedge = nedge->next; continue; }
		     /*
		     fprintf(f, "[ fin=%d n=%d ]", nedge->final, nedge->n);
		     */
                     c1 = config(nedge->n); 
		     if (F_0_(nedge->final)) { Setminus(c1, c2, conf2); break; }
		     if (F_1_(nedge->final)) { Setminus(c2, c1, conf2); break; }
                     }
               if ( ! nedge ) { printf("\nOHA(2)\n"); exit(1); }
               } /* e1 >= 0 */
            else { /* e1 < 0 */
		 c1 = config( (search_enod(e1))->cutoff ); 
		 Setminus(c1, c2, conf2);
		 }
	    /*
	    fprintf(f, "\n");
	    PrintConfig(c1, f, 2);
	    fprintf(f, "\n");
            PrintConfig(c2, f, 2);
	    fprintf(f, "\n");
            PrintConfig(conf2, f, 2);
	    fprintf(f, "\n\n");
	    */
	    fpConfTN(f, conf2, tabulator);
	    /*
	    fprintf(f, "\n\n");
	    */
            e2 = e1; 
 	    e1 = ee2; 
            if ( e2 == from ) break; 
            } /* while(1) */
	fprintf(f, ")\n");
        free(tabulator);
}
/**************************************************************************/
void NB_PrintTransSeq(FILE *f, int *path, int from, int to)
{
	int i=0, *tabulator, e1, e2 , ee1, ee2;
	Edge *nedge;
 	ConfS c1, c2;
      
	tabulator = (int *) MyMalloc(sizeof(int));
        *tabulator = 0;
	if ( IS(CUTOFF, from) )
	     PrintConf_TN( f, config( correspond(from) ) ); 
	else PrintConf_TN( f, config(from) ); 
	fprintf(f,"\n\n(");
 	e2 = from;
	e1 = to;
        while (1) {
	    c1 = (ConfS ) NULL;
            if ( IS(CUTOFF, e2) ) c2 = config( correspond(e2) ); 
	    else c2 = config(e2);
	    ee2 = from;
            if (e1 != from) {
                while ( path[scc_idx(ee2)] != e1 ) { 
                    ee1 = path[scc_idx(ee2)]; 
 		    ee2 = ee1;
		    }
                }
            /* next edge to print is [n]\[cor(e2)] */
 	    nedge = adjacents(e2);
	    while ( nedge ) {
 	        if ( nedge->adj != e1 ) { nedge = nedge->next; continue; }
		if ( nedge->final == F_00 )  {
                     c1 = config(nedge->n); Setminus(c1,c2,conf2); break; }
		if ( nedge->final == F_10 )  {
                     c1 = config(nedge->n); Setminus(c2,c1,conf2); break; }
                }
            if (c1 == NULL) { printf("\nBuechiTrans in NB-Cycle!\n\n");
		              exit(1); }
	    fpConfTN(f, conf2, tabulator);
            e2 = e1; 
 	    e1 = ee2; 
            if (e2 == from) break; 
            }	
	fprintf(f, ")\n");
        free(tabulator);
}
/**************************************************************************/
void X_NB_PrintTransSeq(FILE *f, int *path, int from, int to)
{
	int    i=0, *tabulator, e1, e2 , ee1, ee2, p_2;
	Edge   *nedge;
	ENode  *en;
	ENCorr *encorr;
 	ConfS  c1, c2;
      
	tabulator = (int *) MyMalloc(sizeof(int));
        *tabulator = 0;

	/*** print initial Transition-Sequence ***/
	if ( from > 0 ) {
	     if ( IS (CUTOFF, from) ) {
	            PrintConf_TN( f, config( correspond(from) ) ); }
	     else { PrintConf_TN( f, config(from) ); }
	     }
        else { en = search_enod(from);
	       if ( EN_IS(LOCAL, en) ) {
		      c1 = config( (int) en->corr);
		      PrintConf_TN(f, config( (int) en->corr )); }
               else { encorr = en->corr;
		      IL2CONF(encorr->conf, conf4, ba_idx(encorr->max->i) );
		      PrintConf_TN(f, conf4); }
             }
	       
	/*** print loop ***/       
	fprintf(f,"\n\n(");
 	e2 = from;
	e1 = to;
        while ( 1 ) {
	    if ( e2 >= 0 ) {
                   if ( IS(CUTOFF,e2) ) 
			c2 = config( correspond(e2) );
	           else c2 = config(e2); }
            else { if ( EN_IS(LOCAL, search_enod(e2)) ) 
			  c2 = config( (int) (search_enod(e2))->corr );
                   else { encorr = (search_enod( e2 ))->corr;
			  IL2CONF(encorr->conf,conf1,ba_idx(encorr->max->i));
                          c2 = conf1; }
                 }
	    ee2 = from;
            if (e1 != from) {
		if ( ee2 >= 0 ) p_2 = path[scc_idx(ee2)];
		else p_2 = path[EN_scc_idx(search_enod(ee2))];
                while ( p_2 != e1 ) { 
                    ee1 = p_2; 
 		    ee2 = ee1;
		    if ( ee2 >= 0 ) p_2 = path[scc_idx(ee2)];
		    else p_2 = path[EN_scc_idx(search_enod(ee2))];
		    }
                }
            /*** detected: e2 --> e1 ***/
	    /*
	    fprintf(f, "\n %d ", e2);
	    if (e2>0 && IS(CUTOFF,e2)) fprintf(f,"(%d)", correspond(e2));
	    if (e2 < 0) fprintf(f,"[%d]", (search_enod(e2))->cutoff);
	    fprintf(f," --> %d ", e1);
	    if (e1>0 && IS(CUTOFF,e1)) fprintf(f,"(%d)", correspond(e1));
	    if (e1 < 0) fprintf(f,"[%d]", (search_enod(e1))->cutoff);
	    fprintf(f, "\n");
	    */
            /* next edge to print is [n]\[cor(e2)] */
	    if ( e1 >= 0 ) {
	       if ( e2 >= 0 ) {
		    if (IS(CUTOFF, e2)) 
			 nedge = adjacents(e2);
		    else nedge = __adjacents(e2); }
               else { if ( EN_IS(LOCAL, search_enod(e2)) )
			     nedge = __adjacents((int) (search_enod(e2))->corr );
			else nedge = (search_enod(e2))->corr->adjs;
		    }
	       while ( nedge ) {
 	             if ( nedge->adj != e1 ) { nedge = nedge->next; continue; }
		     if ( nedge->final == F_00 ) {
			c1 = config(nedge->n); Setminus(c1,c2,conf2); break; }
		     if ( nedge->final == F_10 ) {
			c1 = config(nedge->n); Setminus(c2,c1,conf2); break; }
                     }
               if (c1==NULL) { printf("\nBuechi-Trans in NB-cycle!\n");
			       exit(1); }
               } /* e1 >= 0 */
            else { /* e1 < 0 */
		 if ( ! F__0(search_enod(e1)->final) ) {
		    printf("\nBuechi-Trans in NB-cycle!\n"); exit(1); }
		 c1 = config( (search_enod(e1))->cutoff ); 
		 Setminus(c1, c2, conf2);
		 }
            /*
	    PrintConfig(c1, f, 2);
            PrintConfig(c2, f, 2);
	    */
	    fpConfTN(f, conf2, tabulator);
            e2 = e1; 
 	    e1 = ee2; 
            if ( e2 == from ) break; 
            } /* while(1) */
	fprintf(f, ")\n");
        free(tabulator);
}
/***********************************************************************/
void Print_AcceptAll(FILE *f, int event)
{	fprintf(f, "\"Accept_all\" place reachable!\n");
	PrintConfig(f, config(event), 4);
	fprintf(f, "\n");
}
/**************************************************************************/
char Print_CounterExamples()
{
	FILE *f;
	char line[MAXLINE], _line_[MAXLINE], trans[MAXCHAR], _trans_[MAXCHAR];
	register int pos, _pos_, j, _j_;

	f = FileOpen(incomplCtrEx, "r");
	fgetline(f, line, MAXLINE);
	if (line[0] == 'N') { unlink(incomplCtrEx); return(0); }
	if (line[0] != 'Y') { 
	    fprintf(stderr, "\nOha... consult wallnerf@in.tum.de\n"); 
	    exit(1); }
	printf("(incomplete)\n\nNO.\n\nCounterexample:\n");
	fgetline(f, line, MAXLINE);
	fgetline(f, _line_, MAXLINE);
	if (_line_[1] == ')') {
	    printf("(%s)\n", line);
	    unlink(incomplCtrEx);
	    return(1); }
	j = 0;
	_j_ = 1;
	printf("%s", line); 
	printf("(");
	while (_line_[_j_] != ')') {
	      pos = _pos_ = 0;
	      while (_line_[_j_] != ',' && _line_[_j_] != ')' ) 
		     _trans_[_pos_++] = _line_[_j_++];
	      _trans_[_pos_] = '\0';
	      if (_line_[_j_] != ')') _j_++; 
	      /*** ... now _trans_ is the next [e^0]-transition ***/
	      while (line[j] != ',' && line[j] != '\n') 
		     trans[pos++] = line[j++];
	      trans[pos] = '\0';
	      if (line[j] != '\n') j++; 
	      /*** ... now trans is the next [e] transition ***/

	      while (strcmp(_trans_, trans) != 0 ) {
	             printf("%s,", trans);
	             pos=0;
	             while (line[j] != ',' && line[j] != '\n') 
			    trans[pos++] = line[j++];
		     trans[pos] = '\0'; 
		     if (line[j] != '\n') j++; 
		     }
	      }
        while (line[j] != '\n') {
	      pos = 0;
	      while (line[j] != ',' && line[j] != '\n') 
		     trans[pos++] = line[j++];
	      trans[pos] = '\0';
	      if (line[j] != '\n') j++; 
	      printf("%s,", trans);
	      }
        printf("\b)\n\n");
	fclose(f); unlink(incomplCtrEx);
	return(1);
}
/**************************************************************************/
void sPrintConfig(ConfS conf, char* s, int transnums)
/* transnums = 0 : E1,B2,E9,F12,....
   transnums = 1 : E1,E2,E9,E12,....,CUT_E109,
   transnums = 2 : E1(T4),E2(_c_T1),E9(T12),E12*(_c_T2),...
   transnums = 3 : T4,_c_T1,T12,_c_T2,...
   transnums = 4 : T4,T12,....
   transnums = 9 : (print Cuts!) B123,B124,B340,B345,...               */
{
	register int   	bit, w, i=0;
	char 		c;
 	ElemS	  	x;

	s[0] = '\0';
	while ( (x=conf[i]) != BA_ALL) {
	    if (x == 0) { i++; continue; }
	    w = BA_BASE*(i++);
	    for ( bit=0; bit<BA_BASE; bit++, w++ ) {
		if (x < bitmask[bit]) continue;
		x -= bitmask[bit];
		if (transnums==9) c = 'B';
                else              c = 'E';
		if (transnums==0) {
                           if (IS(BUECHI,w)) c = 'B';
		           if (IS(FINAL,w))  c = 'F';}
                if (transnums==1 && IS(CUTOFF,w)) strcat(s,"CUT_");
                if (transnums != 3 && transnums != 4 && transnums != 7)
		           sprintf(s,"%s%c%d", s, c, w);
                if (transnums==2 && IS(FINAL,w)) strcat(s,"*");
                if (transnums==2) strcat(s,"(");
                if (transnums==2 || transnums==3)
                           sprintf(s,"%s%s", s, TransName(w));
                if (transnums==7) {
                           sprintf(s,"%s%s(%d)", s, TransName(w),T_NAME(w));
			   }
                if (transnums==4 && !IS(BUECHI,w))
                           sprintf(s,"%s%s,", s, TransName(w));
                if (transnums==2) strcat(s,")");
                if (transnums != 4) strcat(s,","); 
		if (x == 0) break;
	        }
	    }
}
/***************************************************************************/
void PrintTPL(trans_PL *t)
{
	if (t == NULL) { printf("-"); return; }
	if ( TPL_OP(t) ) {
	   if (t->op == (char *) TPL_NOT)   { printf("!("); 
				              PrintTPL(t->lop); 
				              printf(")"); 
				              return;}
	   if (t->op == (char *) TPL_TRUE)  { printf("tt"); return;}
	   if (t->op == (char *) TPL_FALSE) { printf("ff"); return;}
	   if (t->op == (char *) TPL_AND)   { printf("(");
				              PrintTPL(t->lop);
				              printf(" & ");
				              PrintTPL(t->rop);
				              printf(")"); return;}
	   if (t->op == (char *) TPL_OR)    { printf("(");
				              PrintTPL(t->lop); 
				              printf(" | "); 
				              PrintTPL(t->rop); 
				              printf(")"); return;}
           }
        else printf("%s", t->op);
}
/***************************************************************************/
void PrintTPL_ALL(FILE* f, trans_PL *t)
{
	if (t == NULL) { return; }
	fprintf(f, "%u ", t);
	if (TPL_OP(t)) fprintf(f, "(%d) ", (int) t->op);
	else fprintf(f, "(%s) ", t->op);
	fprintf(f, " -L- %u ", t->lop);
	fprintf(f, " -R- %u\n ", t->rop);
	PrintTPL_ALL(f, t->lop);
	PrintTPL_ALL(f, t->rop);
}
/***************************************************************************/
void ShowStatistics()
{
	int i;

	printf("\nStatistics:\n===========\n");
	printf("%s:           ", sys_net);
	printf("|P| = %5d ", _P_sys); 
	printf("|T| = %5d \n", _T_sys); 
	if (initialize_net) { printf("%s[init]:     ", sys_net);
	                      printf("|P| = %5d ", _P_init); 
	                      printf("|T| = %5d\n", _T_init); }
	printf("%s:      ", syncllnet); 
	printf("|P| = %5d ", _P_sync); 
	printf("|T| = %5d \n", _T_sync); 
	printf("%s:              ",unfolding);
	printf("|B| = %5d ", real_B_Fin); 
	printf("|E| = %5d ", E_Fin); 
	if ( E_off ) {
	       printf("\n");
	       i = 0;
	       while ( i++ < strlen(syncllnet) ) printf(" ");
	       printf("                cutoffs: %5d\n", E_off);
	       i = 0;
	       while ( i++ < strlen(syncllnet) ) printf(" ");
	       printf("                  corrs: %5d\n\n", E_corr); 
	       }
	else { printf("\n\n"); return; }
	if (ffcomp1) {
	    printf("local states (nodes): %d\n", E_corr);
            i = 3; 
	    while ( ++i < strlen(unfolding) ) printf("%c", unfolding[i-4]);
	    printf(".GRAPH:     (vis)  ");
	    printf("scc = %5d ", ffcomp1);
	    printf("acc = %5d\n", ffacc1); }
	if (fncomp1) {
            i = 3; 
	    while ( ++i < strlen(unfolding) ) printf("%c", unfolding[i-4]);
	    printf(".GRAPH:    (invis) ");
	    printf("scc = %5d ", fncomp1);
	    printf("acc = %5d\n", fnacc1); }

        if (EN_idx) {
	    printf("computed global states: %d\n", EN_idx); }
	if (ffcomp2) {
            i = 3; 
	    while ( ++i < strlen(unfolding) ) printf("%c", unfolding[i-4]);
	    printf(".X_GRAPH:   (vis)  ");
	    printf("scc = %5d ", ffcomp2);
	    printf("acc = %5d\n", ffacc2); }
	if (fncomp2) {
            i = 3; 
	    while ( ++i < strlen(unfolding) ) printf("%c", unfolding[i-4]);
	    printf(".X_GRAPH:  (invis) ");
	    printf("scc = %5d ", fncomp2);
	    printf("acc = %5d\n", fnacc2); }

        printf("\n\n"); 
	printf("Elapsed Time:    %f\n----------------\n", all_time_f);
	printf("Synchronisation: %f\n", sync_time_f); 
	printf("Unfolding:       %f\n", unf_time_f); 
	printf("LTL-checker:     %f\n", 
	       ( all_time_f - (unf_time_f + sync_time_f) ) ); 
	printf("\n\n");
}
/***********************************************************************/
void Print_LTL_Syntax()
{
	printf("\nLTL-Syntax\n\n");
	printf("f  ::=  prop | (f) | -f | f*f | f+f | f=>f | F f | G f | f U f\n\n");
	printf("prop       == atomic propositions (see below)\n");
	printf("- f        == NOT f\n");
	printf("f1 * f2    == f1 AND f2\n");
	printf("f1 + f2    == f1 OR f2\n");
	printf("f1 => f2   == f1 IMPLIES f2\n");
	printf("F f        == EVENTUALLY f\n");
	printf("G f        == ALWAYS (GLOBALLY) f\n");
	printf("f1 U f2    == f1 UNTIL f2\n\n\n\n");
	printf("prop ::=  true | false | place_name | x=n | x<n | x>n | x<=n | x>=n\n\n");
	printf("where 'x' is a variable and 'n' a value (as used in B(PN)^2)\n\n");
	printf("comments, in brackets /* ... */, are allowed anywhere\n");
	printf("\n");
}
/***********************************************************************/
void Print_Usage(char *prog)
{
	printf("'%s' -- ", prog);
	printf("check LTL properties of safe, deadlock-free Petri nets.\n\n");
	printf("Usage:   ");
	printf("%s <net> [<prop>] [-bcfgimpqusCFP]\n\n", prog);
	printf(" <net>   is a file containing a safe, deadlock-free Petri net\n");
	printf("         (in PEP format, except with flag -P, see below )\n");
	printf("<prop>   is a file containing a linear-time temporal property:\n");
	printf("         either   a LTL-formula (type  '%s -y'  for syntax)\n", prog);
	printf("         or       a Buechi automaton (in spin-format)\n\n");
        printf("  -b     \"break off\" -- search a counterexample during unfolding process\n");
        printf("                        and exit immediately (with uncomplete unfolding)\n");
        printf("  -c     \"complete\"  -- compute all counterexamples\n");
        printf("  -f     \"first\"     -- compute the complete unfolding, but exit with\n");
	printf("                        first counterexample\n");
	printf("         Default     -- completely compute the unfolding, and find\n");
	printf("                        a \"reasonable\" counterexample\n\n");
	printf("  -i     initializes all variables (remove 'begin' & 'exit' transitions)\n");
	printf("         (recommended only when the net is an unfolded HL-Net)\n");
        printf("  -m     use McMillan's unfolding algor. (default is Esparza/Roemer/Vogler)\n");
	printf("  -p     display progress status (1 line) during unfolding process\n");
	printf("  -g     display progress status (several lines) during graph extension\n");
	printf("  -q     \"quiet\" - all (relevant) output into <net>.out\n");
        printf("  -u     use already computed unfolding\n");
        printf("  -s     display some statistics\n");
        printf("  -C     \"clean up\" -- remove all <net>.* files created by %s\n", prog);
        printf("         (if <prop> is specified, the resp. files are also removed)\n");
	printf("  -F     translate <net>  PROD --> PEP\n");
	printf("  -P     translate <net>  PEP  --> PROD\n");
	printf("         (the optional LTL-formula <prop> is also translated)\n");	
	printf("  -S     stop after synchronisation\n");
        /*printf("   -A   do NOT save the automaton as spin-file\n");*/
        /*printf("   -L   DO save the automaton as LL-Net\n");*/
        /*printf("   -x : extended information in scc-file (counterexamples)\n");*/
       
        printf("\n"); 

}
/***********************************************************************/
void Clean_Up(char *net, char *prop, char *prog_name)
{
	FILE *f;
	char fname[MAXCHAR];
	char foundsth=0;

	strcpy(fname, net); strcat(fname, ".init.ll_net");
	if ((f=fopen(fname, "r"))) { fclose(f); unlink(fname); foundsth=1; }
	strcpy(fname, net); strcat(fname, ".out");
	if ((f=fopen(fname, "r"))) { fclose(f); unlink(fname); foundsth=1; }
	strcpy(fname, net); strcat(fname, ".net");
	if ((f=fopen(fname, "r"))) { fclose(f); unlink(fname); foundsth=1; }
	strcpy(fname, net); strcat(fname, ".ctrex");
	if ((f=fopen(fname, "r"))) { fclose(f); unlink(fname); foundsth=1; }
	strcpy(fname, net); strcat(fname, ".scc");
	if ((f=fopen(fname, "r"))) { fclose(f); unlink(fname); foundsth=1; }
	strcpy(fname, net); strcat(fname, ".sync.ll_net");
	if ((f=fopen(fname, "r"))) { fclose(f); unlink(fname); foundsth=1; }
	strcpy(fname, net); strcat(fname, ".unf");
	if ((f=fopen(fname, "r"))) { fclose(f); unlink(fname); foundsth=1; }
	if (! foundsth) printf("no net files '%s.*' (created by %s).\n", \
		                net, prog_name);

	if (prop[0] == '-') return;
	foundsth = 0;

	strcpy(fname, prop); strcat(fname, ".aut.ll_net");
	if ((f=fopen(fname, "r"))) { fclose(f); unlink(fname); foundsth=1; }
	strcpy(fname, prop); strcat(fname, ".aut");
	if ((f=fopen(fname, "r"))) { fclose(f); unlink(fname); foundsth=1; }
	if (! foundsth) printf("no property files '%s.*' (created by %s).\n", \
		                prop, prog_name);
}
/***********************************************************************/
void PrintIL(Int_List *il, int tn)
{
	Int_List *ilp;

	ilp = il;
	while (ilp) {
	      printf("(%d)", (ilp->i)); 
	      if (tn==2) printf("[%u]", ilp); 
	      printf("->"); fflush(stdout);
	      ilp = ilp->next; }
      	printf("NIL\n");
}
/***********************************************************************/
void fPrintIL(FILE *f, Int_List *il, int tn)
{
	Int_List *ilp;

	ilp = il;
	while (ilp) {
	      fprintf(f,"(%d)", (ilp->i)); 
	      if (tn==2) fprintf(f,"[%u]", ilp); 
	      if (tn==3) fprintf(f,"[%s]", TransName(ilp->i)); 
	      fprintf(f,"->"); 
	      ilp = ilp->next; }
      	fprintf(f,"NIL\n");
}
/***********************************************************************/
void PrintMarking(FILE *f, int corr)
{
	Int_List *cut;
	ENode *enode;
	ConfS mark;
	int place_idx, i, w;

	mark = (ConfS ) MyMalloc(BA_SZ * (1+(_P_sync/BA_BASE)));
	enode = (ENode *) enodes(corr);
	while (enode) {
		if ( EN_IS(LOCAL, enode) ){ enode=enode->next; continue; }
		cut = enode->corr->cut;
		while (cut) {
		      place_idx = place_num[cut->i];
		      cut=cut->next;
		      add_entry(mark, place_idx);
		      }
                fprintf(f,"EN%d: ", enode->idx); fflush(stdout);
		for (i=0; i <= (_P_sync/BA_BASE); i++) {
		    fprintf(f," %d ", mark[i]); mark[i] = 0; }
                fprintf(f,"\n");
		fprintf(f,"corr=%d", corr);
		fprintf(f, "[%d]", cutoff_num(corr, 1));
		fprintf(f," co=%d rp=%d (%d)\nMAX:", enode->cutoff, enode->rep,
		correspond(enode->rep));
		cut = enode->corr->max; 
		while (cut) { fprintf(f,"%d ", cut->i); cut=cut->next; }
                fprintf(f,"\n\n");
		enode = enode->next;
		}
	free(mark);
}
/***********************************************************************/
void Print_Marking(FILE* f,  TE_List *tel, int depth )
{
	TE_List *telp;
	Int_List *il;
	ENode *en;

	telp = tel;
	while (telp) {
	     if (depth == (_P_sync/BA_BASE) )  {
	          il = tel->e;
		  if (il->next == IL_NULL) {telp = telp->next;continue;}
		  while (il) { en = (ENode *) il->i; il = il->next; 
		     fprintf(f, "EN %5d: ", en->idx);
		     if (en->src < 0) {
			fprintf(f,"%5d ", (- en->src));
			if (IS(CORR, ( - en->src))) 
			    fprintf(f,"[%5d] ", cutoff_num((- en->src),1));
                        else fprintf(f,"[*****] ");
			}
                     else fprintf(f,"    sub       ");
		     fprintf(f, "off=%5d (%5d) <%5d>", en->cutoff, en->rep,
		     correspond(en->rep));
		     if (EN_IS(LOCAL,en)) {
			    fprintf(f, "MAX: %d ", (int) en->corr);
                            fprintf(f, " ->%d\n", 
				    CountEdges(__adjacents((int) en->corr))); }
		     else { fprintf(f, "MAX: %d ", en->corr->max->i);
		            if (en->corr->max->next) 
				fprintf(f," %d ", en->corr->max->next->i);
		            if (en->corr->max->next && 
				en->corr->max->next->next) fprintf(f," ...");
                            fprintf(f, " ->%d\n", 
				    CountEdges(en->corr->adjs)); 
                          }
		     }
		  fprintf(f, "\n");
		  }
	     else Print_Marking(f, (TE_List *)telp->e, depth+1);
	     telp = telp->next; }
}

int CountEdges(Edge *ed)
{
	Edge *e;
	int ctr = 0;

	e = ed;
	while (e) { ctr++; e = e->next; }
	return(ctr);
}
/***********************************************************************/
void Print_ENCorr_Info(FILE *f, ENode *enod)
{
	ENCorr *global;
	Int_List *il;
	Edge *ne;

	if ( EN_IS(LOCAL, enod) ) { return; }
	global = enod->corr; 
	ne = global->adjs;
	while (ne) {fprintf(f, "\tadj=%d n=%d\n", ne->adj, ne->n);
		    ne = ne->next; }
	il = global->max;
	while (il) {fprintf(f, "%d  ", il->i); il=il->next;}
	fprintf(f,"\n");
	il = global->conf;
	while (il) {fprintf(f, "%d  ", il->i); il=il->next;}
	fprintf(f,"\nlc=%d\n", global->last_corr);
	if (global->last_corr > 0) {
	    ne = __adjacents(global->last_corr);
	    while (ne) { fprintf(f, "\tadj=%d n=%d\n", ne->adj, ne->n);
			 ne = ne->next; }
            }

	return; 
}
/***********************************************************************/
void Print_Edges(FILE *f) 
{	
	Edge *ne;
	int  i, e;

	for (i=0; i<=E_Fin; i++) {
	    if ( ! IS(CUTOFF, i) ) continue;
	    if ( i != representative(i) ) continue;
	    fprintf(f, "\nE%d (corr E%d):\n", i, correspond(i));
	    ne = adjacents(i);
	    while (ne) { fprintf(f, "\tadj=%d n=%d f=%d\n",
	                            ne->adj, ne->n, ne->final);
		         ne = ne->next; }
            }
}
/***********************************************************************/
/* End of File outputs.c        */
/********************************/
