
%{


#include "qq_header.h"

void yyrestart(FILE*);

LMPNet 		bnet;
Place 		syspl, bpl, p_sf, p_ss;
Place  		dp, sys_dp;
Transition 	tr, dt, sys_dt;
STEdge 		st, sys_st;
TSEdge 		ts, sys_ts;
Cardinal32 	bpl_num, btr_num, spl_num, str_num, oldpnum;
SET 		akt_vars, universum;
char 		phi[MAXLINE], name[MAXNAME];
char 		sys_call[MAXNAME];
trans_PL  	*tpl_new;
BuechiTrans     *BTrans_new;
FILE 		*pfile; 
PROPO 		pro = (PROPO) NULL;

%}


%union {    EXPR_constr  expr_constr;
	           char  string[MAXLINE];
           unsigned int  number;
       };


%token SPINNEVER, NEVER, IF, FI, COLON
%token LEFT_PAREN, RIGHT_PAREN, LEFT_BRACE, RIGHT_BRACE, F_EOF, PRIME
%token SEQ, F_ALWAYS
%token F_SOME
%token IMP, GOTO, SKIP, F_IMP, F_EQ, F_LESS, F_GREATER, F_LESS_EQ, F_GREATER_EQ
%token F_UNTIL

%token NOT, F_NOT
%token OR, F_OR
%token AND, F_AND
%token <number> CONST
%token <string> PROP, LABEL, COMMA, PLACE

%type <expr_constr> expr, formel
%type <string> spin_expr, aut_atomic_prop, atomic_prop, val_prop, spin_labels

%left F_ALWAYS F_SOME
%left F_UNTIL
%left F_IMP
%left OR F_OR
%left AND F_AND
%nonassoc NOT F_NOT

/*************************************************************************/
%start claim_or_form_claim

%%

claim_or_form_claim : form_claim 
		      { freopen(automaton, "r", yyin); } 
		      claim 
		      {if ( ! print_automaton ) {
			  sprintf(sys_call, "\\rm %s", automaton);
			  system(sys_call); }
		      }
		    | claim F_EOF { if (!print_automaton) {
					sprintf(sys_call, "\\rm %s", automaton);
					system(sys_call); }
			  	  }

form_claim : { phi[0] ='\0'; 
               strcat(phi, "!( ");
               prod_formel[0] = '\0' ;
               strcat(prod_formel, "#verify ( "); } 
             formel 
             { strcat(phi, " )");
               strcat(prod_formel, " );"); }
	     F_EOF 
	     { 
printf("path is %s\n",getenv("PATH"));
               sprintf(sys_call, "spin -f \"%s\" > %s", phi, TMP_FILE1);
printf("syscall is %s\n",sys_call);
printf("\n%s\n",phi);
  	       if ( system(sys_call) ) {
		    printf("\nExecution of 'spin' failed.\n");
		    printf("Please make sure to include 'spin' into your search path.\n");
		    exit(1);
		    }
               Make_Spinnever();
	       sprintf(sys_call, "\\rm %s", TMP_FILE1);
	       system(sys_call);
	       freopen(TMP_FILE2, "r", yyin);
               pfile = FileOpen(automaton, "w");
	       sprintf(sys_call,"never {  /* %s */\n", phi);
	       fputline(pfile,sys_call,MAXLINE);
		yyrestart(yyin);
	     }
	     spin_claim
             { 
               while ( pro ) { PROPO old = pro->next; 
		               free(pro); pro = old; };
               fputline(pfile,"}\n",MAXLINE);
               fclose(pfile);
	       sprintf(sys_call, "\\rm %s", TMP_FILE2);
	       system(sys_call);
             };

formel : atomic_prop {PROPO p;
	              char dummy[PROP_LENGTH];
		      if (strcmp($1, "false") == 0 ||
			  strcmp($1, "true") == 0 ) {
				    strcat(phi, $1);
				    strcat(prod_formel, $1);
				    }
                      else {
	                 p = find_guard($1);
                         if ( p ) { sprintf(dummy, "prop%u", p->nr);
                                    strcat(phi, dummy); 
				    strcat(prod_formel, $1); }
		         else     { p = insert_prop($1);
		                    strcat(phi, p->prop_name); 
				    strcat(prod_formel, $1); }
                         }
                      }
       | F_NOT    { strcat(phi, "!( ");
                    strcat(prod_formel, "not( "); } 
                  formel  
                  { strcat(phi, " )"); 
                    strcat(prod_formel, " )"); }
       | formel dual_formel 
       | F_SOME   { strcat(phi, "<>( ");
		    strcat(prod_formel, "eventually( "); } 
                  formel 
                  { strcat(phi, " )"); 
                    strcat(prod_formel, " )"); }
       | F_ALWAYS { strcat(phi, "[]( ");
                    strcat(prod_formel, "henceforth( "); } 
                  formel 
                  { strcat(phi, " )"); 
                    strcat(prod_formel, " )"); }
       | LEFT_PAREN { strcat(phi, "( "); 
		      strcat(prod_formel," ("); }
		    formel {/*$$.tpl=$2.tpl; WHERE DID THIS COME FROM? */}
		    RIGHT_PAREN { strcat(phi," )");
				  strcat(prod_formel, " )"); }

dual_formel : F_AND   { strcat(phi, "/\\"); strcat(prod_formel, " and "); }  
                       formel  
            | F_OR    { strcat(phi, "\\/"); strcat(prod_formel, " or "); }  
   		       formel   
            | F_UNTIL { strcat(phi, " U "); strcat(prod_formel, " until "); }  
             	       formel  
            | F_IMP   { strcat(phi, "->");  strcat(prod_formel, " implies "); }
		       formel
            ;

atomic_prop : LABEL { strcpy($$,$1); }
	    | LABEL val_prop { sprintf($$,"%s%s", $1, $2); }

val_prop : F_EQ CONST         { sprintf($$,"=%d",$2); }
	 | F_LESS CONST       { sprintf($$,"<%d",$2); }
	 | F_GREATER CONST    { sprintf($$,">%d",$2); }
	 | F_LESS_EQ CONST    { sprintf($$,"<=%d",$2); }
	 | F_GREATER_EQ CONST { sprintf($$,">=%d",$2); }
         ;

/***************************************************************************/

claim : NEVER LEFT_BRACE
	{
	 sys_dp = dp = syspl = bpl = p_sf = p_ss = (Place) NULL;
	 sys_dt = dt = tr = (Transition) NULL;
	 sys_st = st = (STEdge) NULL;
	 sys_ts = ts = (TSEdge) NULL;
	 bpl_num = btr_num = 1;
	 spl_num = sysnet->LastPlace->numname;
	 oldpnum = spl_num++;
	 str_num = sysnet->LastTransition->numname;
	 str_num++;
	 bnet=empty_net();
	 CM_use_imarks = True;
	}
	state
	RIGHT_BRACE
	{
         int i, muo = max_used_obs(&observer);

         Create_Scheduler(bpl_num);
         bpl_num++; bpl_num++;
         _TBuechi_ = btr_num - 1;
         _PBuechi_ = bpl_num - 1;
         propositions = (char**) Malloc(muo*sizeof(char*));
	 for (i=0; i<muo; i++) 
 	     propositions[i] = (char *) MYstrdup(obs_name(i, &observer));
 	}
      ;

state : labels  
	IF transitions FI SEQ state
      | labels
	SKIP state
      | labels 
	CONST SEQ state
      | 
      ;

labels : LABEL COLON LABEL COLON 
	 {
	  char   meaning[MAXNAME], pbuechi1[MAXNAME], pbuechi2[MAXNAME];
          int    pos;
          Place  dummy, dummy2, dummysys;

	  sprintf(pbuechi1, "_buechi_%s", $3);
	  sprintf(pbuechi2, "_buechi_%s", $1);
          sprintf(meaning, "#_buechi_%s", $3);

	     dummy = Find_P(bnet,pbuechi1);
	    dummy2 = Find_P(bnet,pbuechi2);
	  dummysys = Find_P(sysnet, pbuechi2);

	
	  if ( (dummy == (Place) NULL) && (dummy2==(Place) NULL) ) {
	     bpl = New_Place(bnet, bpl_num, 0, &dp);
             bpl->label = EMPTY; 
	     bpl->numname = bpl_num;
             SET_PL_MEANING(bpl, meaning);
	     SET_PL_X_POS(bpl, __MY_POS);
	     SET_PL_Y_POS(bpl, (__MY_POS*(bpl_num)));
	     _PBuechi_++; 
	     
	     syspl = New_Place(sysnet, bpl_num, 0, &sys_dp);
             syspl->label = EMPTY; 
	     syspl->numname = spl_num;
             SET_PL_MEANING(syspl, meaning);
	     SET_PL_X_POS(syspl, __MY_POS);
	     SET_PL_Y_POS(syspl, (__MY_POS*(spl_num-oldpnum)));
             spl_num++; bpl_num++;

	     if (strcmp(&($3[strlen($3) - 5]), "_init") == 0) {
		 bpl->marks = syspl->marks = 1;
		 initial_state = bpl->numname;
		 }
	     }
	  else
	    {if (dummy == (Place) NULL) dummy=dummy2;
	     if (strcmp(&($3[strlen($3) - 5]), "_init") == 0)  {
	         dummy->marks = dummysys->marks = 1;
		 initial_state = dummy->numname;
		 }
	       bpl = dummy;	
	     syspl = dummysys;	
	    }
	 }
       | LABEL COLON
	 {char meaning[MAXMEANING], pbuechi[MAXNAME];
          Place dummy, dummysys;

	  sprintf(pbuechi, "_buechi_%s", $1);
          sprintf(meaning, "#%s", pbuechi);
	     dummy = Find_P(bnet, pbuechi);
	  dummysys = Find_P(sysnet, pbuechi);


	  if (dummy == (Place) NULL) {
	       bpl = New_Place(bnet, bpl_num, 0, &dp);
	     syspl = New_Place(sysnet, bpl_num, 0, &sys_dp);
	       bpl->numname = bpl_num;
	     syspl->numname = spl_num;
             SET_PL_MEANING(bpl, meaning);
	       SET_PL_X_POS(bpl, __MY_POS);
	       SET_PL_Y_POS(bpl, (__MY_POS * bpl_num));
             SET_PL_MEANING(syspl, meaning);
	       SET_PL_X_POS(syspl, __MY_POS);
	       SET_PL_Y_POS(syspl, (__MY_POS * (spl_num-oldpnum)));
	       _PBuechi_++; spl_num++; bpl_num++;
             }
           else { bpl = dummy; syspl = dummysys; }
	   if (strcmp(&($1[strlen($1) - 5]), "_init") == 0) {
	         bpl->marks = syspl->marks = 1; 
		 initial_state = bpl->numname;
		 }
           else  bpl->marks = syspl->marks = 0; 
	  } 
       ;

transitions: COLON COLON expr IMP GOTO LABEL transitions
	     {Place dummy; 
	      Place dummysys;
	      char meaning[MAXMEANING], pbuechi[MAXNAME];

	      sprintf(pbuechi, "_buechi_%s", $6);
              sprintf(meaning, "#%s", pbuechi);
	         dummy = Find_P(bnet, pbuechi);
	      dummysys = Find_P(sysnet, pbuechi);

              if (dummy == (Place) NULL) {
 	         dummy = New_Place(bnet, bpl_num, 0, &dp);
		 dummy->numname = bpl_num;
                 SET_PL_MEANING(dummy, meaning);
    	         SET_PL_X_POS(dummy, __MY_POS);
	         SET_PL_Y_POS(dummy, (__MY_POS*(bpl_num)));
		 _PBuechi_++; 

 	         dummysys = New_Place(sysnet, bpl_num, 0, &sys_dp);
		 dummysys->numname = spl_num;
                 SET_PL_MEANING(dummysys, meaning);
    	         SET_PL_X_POS(dummysys, __MY_POS);
	         SET_PL_Y_POS(dummysys, (__MY_POS*(spl_num-oldpnum)));
		 spl_num++; bpl_num++;
	        }
	    /*create_transitions(sysnet,bnet,$3.str,dummysys,dummy,$3.tpl);*/
	      create_transitions(sysnet,bnet,dummysys,dummy,$3.tpl);
	     };
	   |
	   ;
 
aut_atomic_prop : LABEL {strcpy($$,$1);}
	        | LABEL val_prop {sprintf($$,"%s%s", $1,$2);}


expr :  LEFT_PAREN expr RIGHT_PAREN {$$.str[0] = '(';
				     strcpy(&($$.str[1]), $2.str);
			             $$.str[strlen($2.str) + 1] = ')';
				     $$.str[strlen($2.str) + 2] = '\0';
				     $$.tpl = $2.tpl;
				    }
   	| NOT LEFT_PAREN expr RIGHT_PAREN
		                   {$$.str[0] = '!';
				    $$.str[1] = '(';
				    strcpy($$.str + 2, $3.str);
				    strcpy(&($$.str[2]), $3.str);
				    $$.str[strlen($3.str) + 2] = ')';
				    $$.str[strlen($3.str) + 3] = '\0';

				    tpl_new = NEW_TPL;
				    tpl_new->op = (char *) TPL_NOT;
				    tpl_new->rop = (trans_PL *) NULL;
				    tpl_new->lop = $3.tpl;
				    $$.tpl = tpl_new;
			           }
	| expr AND expr {strcpy($$.str,$1.str);
			 $$.str[strlen($1.str)] = '&';
		         strcpy(&($$.str[strlen($1.str) + 1]), $3.str); 

			 tpl_new = NEW_TPL;
			 tpl_new->op = (char *) TPL_AND;
			 tpl_new->lop = $1.tpl;
			 tpl_new->rop = $3.tpl;
			 $$.tpl = tpl_new;
                        }
	| expr OR expr  {strcpy($$.str,$1.str);
			 $$.str[strlen($1.str)] = '|';
		         strcpy(&($$.str[strlen($1.str) + 1]), $3.str); 

			 tpl_new = NEW_TPL; 
			 tpl_new->op = (char *) TPL_OR; 
			 tpl_new->lop = $1.tpl; 
			 tpl_new->rop = $3.tpl; 
			 $$.tpl = tpl_new;
                        }
        | aut_atomic_prop {
			 if ( myindex( $1, ">" ) >= 0 ) {
				 $$.tpl = MakeTPL_GT($1); }
			 else  { if ( myindex( $1, "<" ) >= 0 ) {
				      $$.tpl = MakeTPL_LT($1); }
                                 else { tpl_new = NEW_TPL;
					tpl_new->rop = (trans_PL *) NULL;
			                tpl_new->lop = (trans_PL *) NULL;
			                tpl_new->op = Strdup($1); 
			                $$.tpl = tpl_new;}
                               }
			}
	| CONST         {tpl_new = NEW_TPL;
			 tpl_new->lop=tpl_new->rop = (trans_PL *) NULL;

			 if ($1 == 0) {
			     strcpy($$.str, "ff");  
			     tpl_new->op = (char *) TPL_FALSE;
			     }
			 else if ($1 == 1) {
			     strcpy($$.str,"tt"); 
			     tpl_new->op = (char *) TPL_TRUE;
			     }
			 $$.tpl = tpl_new;
		        }
	;

/************************************************************************/

spin_claim : SPINNEVER LEFT_BRACE
	     spin_state
	     RIGHT_BRACE
           ;

spin_state : spin_labels  
	     IF {fputline(pfile,"\tif\n",MAXLINE);}
	     spin_transitions 
	     FI SEQ {fputline(pfile,"\tfi;\n",MAXLINE);}
	     spin_state
           | spin_labels 
	     SKIP {fputline(pfile,"\tskip\n",MAXLINE);}
	     spin_state
           | spin_labels 
	     CONST SEQ {fputline(pfile,"\t0;\n", MAXLINE); }
	     spin_state
	   |
           ;

spin_labels : LABEL COLON LABEL COLON 
			  {char dummy[PROP_LENGTH];
			   sprintf(dummy,"%s:\n",$1);
			   fputline(pfile,dummy,PROP_LENGTH);
			   sprintf(dummy,"%s:\n",$3);
			   fputline(pfile,dummy,PROP_LENGTH);
			   }
	  
            | LABEL COLON {char dummy[PROP_LENGTH];
			   sprintf(dummy,"%s:\n",$1);
			   fputline(pfile,dummy,PROP_LENGTH);
			   }
            ;

spin_transitions: COLON COLON spin_expr IMP GOTO LABEL spin_transitions
	          { char dummy[MAXLINE];
	            strcpy(dummy,"\t:: ");
	            strcat(dummy, $3);
	            strcat(dummy, " -> goto ");
	            strcat(dummy, $6);
		    strcat(dummy,"\n");
	            fputline(pfile,dummy,MAXLINE);
	           }
	        |
	        ;
 
spin_expr : LEFT_PAREN spin_expr RIGHT_PAREN {sprintf($$,"(%s)", $2);}
   	  | NOT LEFT_PAREN spin_expr RIGHT_PAREN { sprintf($$,"!(%s)", $3);}
	  | spin_expr AND spin_expr {sprintf($$, "(%s && %s)", $1, $3);}
	  | spin_expr OR spin_expr  {sprintf($$, "(%s || %s)", $1,$3);}
	  | PROP  {PROPO d = find_prop_name($1);
		   if (d==(PROPO) NULL) {
				fprintf(stderr,"\nparse: Fatal error: ");
				fprintf(stderr,"no PROP %s found\n", $1);
				exit(1);
				}
		   strcpy($$, d->guard);
                   }
	  | CONST {if ($1==1) strcpy($$,"1"); else strcpy($$,"0");}
	;


%%

#include "lex.yy.c"

extern int yylineno;

yyerror(char *token)
{
	fprintf(stderr,"\nERROR in line %u: \"%s\" ", yylineno, yytext);
	fprintf(stderr,"%s\n",token);
	exit (1);
}
