/*****************************/
/* pf.c               5.3.98 */
/* Frank Wallner             */
/*****************************/

#include "qq_header.h"

PROPO find_prop_name(char *name)
{
  	PROPO prop = pro;

  	while ( prop ) { 
	      if ( strcmp(prop->prop_name, name) == 0 ) return(prop);
	      prop = prop->next; }
  	return( (PROPO) NULL );
}
/*************************************************************************/
PROPO find_guard(char *new_guard)
{
  	PROPO prop = pro;

  	while ( prop ) {
    	      if ( strcmp(prop->guard, new_guard) == 0 ) return(prop);
	      prop = prop->next; }
  	return( (PROPO) NULL );
}
/*************************************************************************/
PROPO insert_prop(char *new_guard)
{
  	PROPO new = (PROPO) MyMalloc( sizeof(propo_elm) );

  	new->next = pro;
  	new->nr   = (new->next ? new->next->nr + 1 : 1);
  	sprintf(new->prop_name, "prop%u", new->nr);
  	strcpy (new->guard, new_guard);
  	pro = new;
  	return(pro);
}
/*************************************************************************/
short max_used_prop()
{
  	return( pro ? pro->nr : 0 );
}
/*************************************************************************/
Place Find_P(LMPNet net, char *ann)
{
        char *pmean;
	Coords co;
	Place pl = net->Places;

	while ( pl != P_NULL) {
	  co = (Coords) pl->inscript;
	  if ( ! co ) { pl = pl->nextplace; continue; }
	  if ( ( co = co->next ) && ( co = co->next ) ) 
	     if ( (pmean = (char *) co->x) && *pmean ) 
	        if ( (pmean[0]=='#') && (strcmp(&(pmean[1]),ann)==0) )
	            return(pl);
	  pl = pl->nextplace;
	  }
	return(P_NULL);
}
/*************************************************************************/
Place Insert_Place(LMPNet n, char *pname, Cardinal32 mark, Place *lp)
{
	Coords co;
	Place p;
	int s = sizeof(CoordEntry);
 
	p = fast_insert_place(n, _ZZ_ , mark, lp);
        free(p->name);
        p->name = Strdup(pname);
	p->inscript = (char *) Malloc(s);
	co = (Coords) p->inscript;
	co->x = co->y = (int) NULL;
	co = co->next = (Coords) Malloc(s);
	co->x = co->y = (int) NULL;
	co = co->next = (Coords) Malloc(s);
	co->x = co->y = (int) NULL;
	co = co->next = (Coords) Malloc(s);
	co->x = co->y = (int) NULL;
	co = co->next = (Coords) Malloc(s);
	co->x = co->y = (int) NULL;
	co->next = (Coords) NULL;
	
	return(p);
}
/*************************************************************************/
Transition Insert_Transition(LMPNet n, char *tname, Transition *lt)
{
	Coords co;
	Transition t;
	int s = sizeof(CoordEntry);

	t = fast_insert_transition(n, _ZZ_ , lt);
        free(t->name);
        t->name = Strdup(tname);
	t->inscript = (char *) Malloc(s);
	co = (Coords) t->inscript;
	co->x = co->y = (int) NULL;
	co = co->next = (Coords) Malloc(s);
	co->x = co->y = (int) NULL;
	co = co->next = (Coords) Malloc(s);
	co->x = co->y = (int) NULL;
	co = co->next = (Coords) Malloc(s);
	co->x = co->y = (int) NULL;
	co->next = (Coords) NULL;

	return(t);
}
/*************************************************************************/
TSEdge Insert_TP(LMPNet n, Place p, Transition t, Cardinal32 w, \
		 Place *lp, Transition *lt, TSEdge *lts)
{
	Coords co;
	TSEdge ts;
	int s = sizeof(CoordEntry);

	ts = t->postset;
	while (ts) {
	      if (ts->place->numname == p->numname) return((TSEdge) NULL);
	      ts = ts->nextplace;
	      }

	ts = fast_insert_TP_num(n, p->numname, t->numname, w, lp, lt, lts);
	(int) ts->weight = (char *) Malloc(s);
	co = (Coords) ts->weight;
	co = co->next = (Coords) Malloc(s);
	co->x = co->y = (int) NULL;
	co = co->next = (Coords) Malloc(s);
	co->x = (int) w;
	co->y = (int) NULL;
	co->next = (Coords) NULL;

	return(ts);
}
/*************************************************************************/
STEdge Insert_PT(LMPNet n, Place p, Transition t, Cardinal32 w, \
		 Place *lp, Transition *lt, STEdge *lst)
{
	Coords co;
	STEdge st;
	int s = sizeof(CoordEntry);

	st = p->postset;
	while (st) { 
	      if (st->trans->numname == t->numname) return((STEdge) NULL);
	      st = st->nexttrans;
	      }

	st = fast_insert_PT_num(n, p->numname, t->numname, w, lp, lt, lst);
	(int) st->weight = (char *) Malloc(s);
	co = (Coords) st->weight;
	co = co->next = (Coords) Malloc(s);
	co->x = co->y = (int) NULL;
	co = co->next = (Coords) Malloc(s);
	co->x = (int) w;
	co->y = (int) NULL;
	co->next = (Coords) NULL;
	
	return(st);
}
/*************************************************************************/
void FreeCoords(Coords co)
{
	Coords oldco;

	while ( co ) { oldco = co; co = co->next;
		       oldco->x = oldco->y = 0; free(oldco); }
}
/*************************************************************************/
void create_transitions(LMPNet sn, LMPNet bn, 
			Place sdest, Place bdest, trans_PL *t)
{
	char        pvar[PROP_LENGTH], annotation[MAXLINE];
	char        nextvar[PROP_LENGTH];
	char        c, false_found;
	int         sysxpos, xpos, ypos, sysypos, i=0, j=0;
        int         xmid;
        trans_PL    *tneg, *tnorm, *t2;
        BuechiTrans *trli, *deltrli, *trli2, *deltrli2;  
	OBS         obs = (OBS) NULL;
	Transition  ttt;
	Int_List    *new;

	tnorm = DNF_convert(t);
        deltrli = trli = BTransList(tnorm);

        xmid = (GET_PL_X_POS(bpl) + GET_PL_X_POS(bdest)) / 2;
	xpos = ( ( GET_PL_Y_POS(bpl) > GET_PL_Y_POS(bdest) ) ?
		  xmid - 40 : xmid + 40 ) ;
	sysxpos = xpos;
	ypos = ( GET_PL_Y_POS(bpl) + GET_PL_Y_POS(bdest) ) / 2;
	sysypos = ( GET_PL_Y_POS(syspl) + GET_PL_Y_POS(sdest) ) / 2;
      
        while ( trli ) { 
	     false_found = i = 0; 
             strcpy(annotation, "^["); 
	     while ( 1 ) { 
		   j = 0;
		   while ( ( ( c = (trli->c)[i] ) != ',' ) && (c != '\0') ) { 
			 nextvar[j++] = c; i++; }
		   nextvar[j] = '\0';

		   if (strcmp(nextvar, BT_FALSE) == 0) { false_found=1; break; }
		   if ( strcmp(nextvar,BT_TRUE) != 0 ) {
		      if (nextvar[0] == '!') strcpy(pvar, &(nextvar[1]));
		      else sprintf(pvar, "!%s", nextvar);
		      if ( find_var_name(nextvar, &observer) == (OBS) NULL ) 
		           insert_var_name(nextvar, &observer);
		      if ( find_var_name(nextvar, &obs) == (OBS) NULL ) {
		           insert_var_name(nextvar, &obs);
			   if (find_var_name(pvar, &obs) != (OBS) NULL ) {
			       false_found=1; break; }
		           strcat(annotation, nextvar);
		           strcat(annotation, ",");
                           }
                      }
		   if ( c == ','  ) i++;
                   if ( c == '\0' ) break;
                   }
	     annotation[strlen(annotation)-1] = ']';
	     annotation[strlen(annotation)] = '\0';
	     /*printf("ann: >>%s << (%u)\n", annotation, trli);*/
	     free( trli->c ); trli->c = (char *) NULL; 
	     remove_obs( &obs );

	     if (false_found) { trli=trli->next; continue; }

	     /*** Transition in (internal) BTrans-Structure ***/
             BTrans_new = (BuechiTrans *) MyMalloc(sizeof(BuechiTrans));
	     BTrans_new->trans = btr_num;
	     BTrans_new->il = IL_NULL;
	     BTrans_new->from = bpl->numname;
	     BTrans_new->to = bdest->numname;
	     if ( (GET_PL_MEANING(syspl)) &&
		  (myindex(GET_PL_MEANING(syspl), "accept") >= 0 ) )
		  { BTrans_new->from = - BTrans_new->from; }
	     if ( (GET_PL_MEANING(sdest)) &&
		  (myindex(GET_PL_MEANING(sdest), "accept") >= 0 ) ) 
		  { BTrans_new->to = - BTrans_new->to;
		    if (myindex(GET_PL_MEANING(sdest), "accept_all") >= 0 )
		      { new = NEW_INTLIST;
		        new->i = ( - BTrans_new->to );
		        new->next = Accept_all_List;
		        Accept_all_List = new; }
                  }
             BTrans_new->tpl = (trans_PL *) NULL;
             BTrans_new->c = (char *) NULL;
             BTrans_new->next = BTrans;
             BTrans = BTrans_new;

	     /*** Transition in buechinet ***/
	     tr = New_Transition(bn, btr_num, &dt);
	     tr->numname = btr_num;
             if (strcmp(annotation, "^]") != 0) 
		  SET_TR_MEANING(tr, annotation); 
             else SET_TR_MEANING(tr, "^[tt]");
    	     SET_TR_X_POS(tr, xpos);
	     SET_TR_Y_POS(tr, ypos);
	     xpos += 5; ypos += 5; 
 	     st = Insert_PT(bn,bpl,tr,1,&dp,&dt,&st);
	     ts = Insert_TP(bn,bdest,tr,1,&dp,&dt,&ts);

	     /*** Transition in sysnet ***/
	     tr = New_Transition(sn, btr_num++, &sys_dt);
	     tr->numname = str_num++;
             if (strcmp(annotation, "^]") != 0) 
		  SET_TR_MEANING(tr, annotation); 
             else SET_TR_MEANING(tr, "^[tt]");
    	     SET_TR_X_POS(tr, sysxpos);
	     SET_TR_Y_POS(tr, sysypos);
	     sysxpos += 5; sysypos += 5; 
 	     st = Insert_PT(sn,syspl,tr,1,&sys_dp,&sys_dt,&sys_st);
	     ts = Insert_TP(sn,sdest,tr,1,&sys_dp,&sys_dt,&sys_ts);
             trli = trli->next;
             }
        trli = deltrli;
	while (trli) { deltrli = trli->next;
	               Free_BuechiTrans(trli);
	               trli = deltrli; } 
}
/*************************************************************************/
void Make_Spinnever()
{
	FILE *fin, *fout;
        char line[MAXLINE], newline[(MAXLINE+5)];
        int  i, idx;

	strcpy(newline, "");
        fin = FileOpen(TMP_FILE1, "r");
        fout = FileOpen(TMP_FILE2, "w");
        while (fgetline(fin, line, MAXLINE)) {
	      if ( myindex(line, "tl_spin") >= 0 ) continue;
	      if ( myindex(line, "malloc") >= 0 ) continue;
              if ( (idx = myindex(line, "never {")) < 0 ) {
                         fputline(fout, line, MAXLINE); 
                         continue; }
              for (i=0; i<idx; i++) newline[i] = line[i];
	      strcat(newline, "spin_");
	      while (line[i]!='\0') newline[i+5] = line[i++];
	      newline[i+5]='\0';
	      fputline(fout, newline, (MAXLINE+5));
	      }
        fclose(fin); fclose(fout);
}
/*************************************************************************/
void Create_Scheduler(int pn)
{
	 Coords co;

	 /*step_formula*/
	 p_sf = New_Place(sysnet, pn, 1, &sys_dp);
	 p_sf->label = EMPTY;
	 p_sf->numname = spl_num++;
	 p_sf->marks = 1;
         SET_PL_MEANING(p_sf, "step_formula");
         SET_PL_X_POS(p_sf, SCHED_X_POS);
         SET_PL_Y_POS(p_sf, SCHED_F_Y_POS);
        
	 /*step_system*/
	 p_ss = New_Place(sysnet, (pn + 1), 0, &sys_dp);
         p_ss->label = EMPTY;
	 p_ss->numname = spl_num++;
         p_ss->marks = 0;
         SET_PL_MEANING(p_ss, "step_system");
         SET_PL_X_POS(p_ss, SCHED_X_POS);
         SET_PL_Y_POS(p_ss, SCHED_S_Y_POS);

         tr = sysnet->Transitions;
         while ( tr ) {
             if ( myindex(tr->name, "_c_T") == 0 ) {
	         st = Insert_PT(sysnet,p_sf,tr,1,&sys_dp,&sys_dt,&sys_st);
		 if ( st ) {
		   co = (Coords) st->weight;
		   if ( co && ( co = co->next ) ) co->y = 4; /*invisible arc*/
		   }
	         ts = Insert_TP(sysnet,p_ss,tr,1,&sys_dp,&sys_dt,&sys_ts);
		 if (ts) {
		   co = (Coords) ts->weight;
		   if ( co && ( co = co->next ) ) co->y = 4; /*invisible arc*/
		   }
                 }
             tr = tr->nexttrans; }
}
/*************************************************************************/
void determine_variable(char *s, char *t)
{
	char c;
        int i=0;

        while (((c=s[i]) != '=') && (c != '<') && 
                (c != '>') && (c != '\0') ) t[i++]=c;
        t[i]='\0';
}
/*************************************************************************/
Place  New_Place(LMPNet net, int num, Cardinal32 mark, Place *lp)
{
	char numname[12], PTname[12];
	Place p;

	myint2str(num, numname);
	strcpy(PTname, "");
	sprintf(PTname, "_c_P%s", numname);

	p = Insert_Place(net, PTname, mark, lp);
	p->numname=num;

	return(p);

}
/*************************************************************************/
Transition  New_Transition(LMPNet net, int num, Transition *lt)
{
	char numname[12], PTname[12];
	Transition t;

	myint2str(num, numname);
	strcpy(PTname, "");
	sprintf(PTname, "_c_T%s", numname);

	t = Insert_Transition(net, PTname, lt);
	t->numname=num;

	return(t);
}
/*************************************************************************/
PlaceList  *insert_pl(PlaceList **pl, Place p)
{
	PlaceList *newpl, *plptr;

	plptr = *pl;
	while ( plptr ) {
	      if ( plptr->p == p ) return(plptr);
	      else plptr = plptr->next;
	      }
        newpl = NEWPLIST;
	newpl->p = p;
	newpl->next = *pl;
	*pl = newpl;
	return(newpl);
}
/*************************************************************************/
TransitionList  *insert_tl(TransitionList **tl, Transition t)
{
	TransitionList *newtl, *tlptr;

	tlptr = *tl;
	while ( tlptr ) {
	      if ( tlptr->t == t ) return(tlptr);
	      else tlptr = tlptr->next;
	      }
        newtl = NEWTLIST;
	newtl->t = t;
	newtl->next = *tl;
	*tl = newtl;
	return(newtl);
}
/*************************************************************************/
void  Intersect(PlaceList **ipl, PlaceList **pl)
{
	PlaceList *iptr, *pptr, *result;
	char ok;

	result = PL_NULL;
	if ( *ipl == PL_NULL ) { *ipl = *pl; *pl = NULL; return; }
        iptr = *ipl;
	while ( iptr ) {
	       ok = 0;
	       pptr = *pl;
	       while ( pptr ) {
		     if ( iptr->p == pptr->p )  { ok=1; break; }
		     pptr = pptr->next;
		     }
               if ( !ok ) iptr->p = P_NULL;
	       iptr = iptr->next;
	       }
         iptr = *ipl;
	 while ( iptr ) {
	       if ( iptr->p ) {
		  pptr = NEWPLIST;
		  pptr->p = iptr->p;
		  pptr->next = result;
		  result = pptr;
		  }
               iptr = iptr->next;
	       }
          
	 while ( *ipl ) {
	       pptr = (*ipl)->next;
	       free(*ipl);
	       *ipl = pptr;
	       }
         while ( *pl ) {
	       pptr = (*pl)->next;
	       free(*pl);
	       *pl = pptr;
	       }
         *ipl = result;
}
/*************************************************************************/
Place Complement_Place(Place p)
{
        Place result = P_NULL;
	PlaceList *pl;
	TransitionList *tlp, *tlc ;

	if ( (pl=PPostset(p)) == PL_NULL ) {return(P_NULL);}
	while ( pl ) {
	      if ( (tlp = TPostset(p)) == TL_NULL ) {return(P_NULL);}
	      if ( (tlc = TPreset(pl->p)) == TL_NULL ) {return(P_NULL);}
              if ( Equal_TL(tlp,tlc) ) result = pl->p;
	      Free_TList(tlp);
	      Free_TList(tlc);
	      if ( result == P_NULL ) { pl = pl->next; continue; }
	      result = P_NULL;
	      if ( ( tlp = TPreset(p) ) == TL_NULL ) {
			  result = P_NULL; pl = pl->next; continue;}
	      if ( ( tlc = TPostset(pl->p) ) == TL_NULL ) {
			  result = P_NULL; pl = pl->next; continue;}
              if ( Equal_TL(tlp,tlc) ) result = pl->p;
	      Free_TList(tlc);
	      Free_TList(tlp);
	      if ( result != P_NULL ) break;
	      pl = pl->next;
	      }
 	Free_PList(pl);
	return(result);
}
/*************************************************************************/
Place Create_Complement(LMPNet *n, char *vn, int pn, Place p)
{

        Place cpl, dp = P_NULL;
        Transition dt = T_NULL;
        STEdge st, dst = ST__NULL;
        TSEdge ts, dts = TS__NULL;
	TransitionList *tlist, *tlptr;
        char meaning[MAXNAME], name[MAXNAME];

	cpl = New_Place(*n, bpl_num++, (1 - p->marks), &dp);
        cpl->numname = spl_num++;
	cpl->marks = 1 - p->marks;
        sprintf(meaning, "OBS(%s)", vn);
        SET_PL_MEANING(cpl, meaning);
        SET_PL_X_POS( cpl, (GET_PL_X_POS(p)+50) );
        SET_PL_Y_POS( cpl, (GET_PL_Y_POS(p)+50) );
	tlptr = tlist = TPostset(p);
        tlptr=tlist;
	while ( tlptr ) {
	      ts = (TSEdge) Insert_TP(*n, cpl, tlptr->t, 1, &dp, &dt, &dts);
	      tlptr = tlptr->next;
	      }
        Free_TList(tlist);
	tlptr = tlist = TPreset(p);
	while ( tlptr ) {
	      st = (STEdge) Insert_PT(*n, cpl, tlptr->t, 1, &dp, &dt, &dst);
	      tlptr = tlptr->next;
	      }
        Free_TList(tlist);
	return(cpl);
}
/*************************************************************************/
PlaceList *Real_PPostset(Place p)
{
	STEdge st = p->postset;
	TSEdge ts;
	char exittrans;
	Transition t;
	PlaceList *ipl = (PlaceList*) NULL, *pl=PL_NULL;

        while ( st != ST__NULL ) {
	      if ( is_preset( p, (t=st->trans) ) ) {
		  st = st->nexttrans; continue; }
              ts = t->postset;
	      exittrans = 0;
              while ( ts != TS__NULL ) {
		    if ( ts->place->label == EXIT ) {
		       exittrans = 1; break; }
                    ts = ts->nextplace;
		    }
              if ( exittrans ) {
		  st = st->nexttrans; continue; }
              ts = t->postset;
              while ( ts != TS__NULL ) {
		    insert_pl(&pl, ts->place);
                    ts = ts->nextplace;
                    }
              Intersect(&ipl, &pl);
	      if ( ipl == PL_NULL ) return(PL_NULL);
	      st = st->nexttrans;
              }
	return(ipl);
}
/*************************************************************************/
PlaceList *Real_PPreset(Place p)
{
	STEdge st;
	TSEdge ts = p->preset;
	char entrytrans;
	Transition t;
	PlaceList *ipl = (PlaceList*) NULL, *pl=PL_NULL;

        while ( ts != TS__NULL ) {
	      if ( is_postset(p, (t=ts->trans)) ) {
		  ts = ts->nexttrans; continue; }
              st = t->preset;
	      entrytrans = 0;
              while ( st != ST__NULL ) {
		    if ( st->place->label == ENTRY ) {
		       entrytrans = 1; break; }
                    st = st->nextplace;
		    }
              if (entrytrans) {
		  ts = ts->nexttrans; continue; }
              st = t->preset;
              while (st != ST__NULL) {
		    insert_pl(&pl, st->place);
                    st = st->nextplace;
                    }
              Intersect(&ipl, &pl);
	      if (ipl == PL_NULL) return(PL_NULL);
	      ts = ts->nexttrans;
              }
	return(ipl);
}
/*************************************************************************/
TransitionList *Real_TPostset(Place p)
{
	STEdge st = p->postset;
	TSEdge ts;
	char exittrans;
	Transition t;
	TransitionList *tl = TL_NULL;

        while ( st != ST__NULL ) {
	      if ( is_preset(p, (t = st->trans)) ) {
		  st = st->nexttrans; continue; }
              ts = t->postset;
	      exittrans = 0;
              while (ts != TS__NULL) {
		    if ( ts->place->label == EXIT ) {
		       exittrans = 1; break; }
                    ts = ts->nextplace;
		    }
              if ( exittrans ) { st = st->nexttrans; continue; }
	      insert_tl( &tl, t );
	      st = st->nexttrans;
              }
	return(tl);
}
/*************************************************************************/
TransitionList *Real_TPreset(Place p)
{
	STEdge st;
	TSEdge ts = p->preset;
	char entrytrans;
	Transition t;
	TransitionList *tl=TL_NULL;

        while (ts != TS__NULL) {
	      if (is_postset(p,(t=ts->trans))) {
		  ts = ts->nexttrans; continue; }
              st = t->preset;
	      entrytrans=0;
              while (st != ST__NULL) {
		    if (st->place->label == ENTRY) {
		       entrytrans=1; break; }
                    st = st->nextplace;
		    }
              if (entrytrans) {
		  ts = ts->nexttrans; continue; }
	      insert_tl(&tl, t);
	      ts = ts->nexttrans;
              }
	return(tl);
}
/*************************************************************************/
PlaceList *PPostset(Place p)
{
	STEdge st = p->postset;
	TSEdge ts;
	Transition t;
	PlaceList *ipl = (PlaceList*) NULL, *pl=PL_NULL;

        while ( st != ST__NULL ) {
	      if ( is_preset( p, (t=st->trans) ) ) {
		  st = st->nexttrans; continue; }
              ts = t->postset;
              while ( ts != TS__NULL ) {
		    insert_pl(&pl, ts->place);
                    ts = ts->nextplace;
                    }
              Intersect(&ipl, &pl);
	      if ( ipl == PL_NULL ) return(PL_NULL);
	      st = st->nexttrans;
              }
	return(ipl);
}
/*************************************************************************/
PlaceList *PPreset(Place p)
{
	STEdge st;
	TSEdge ts = p->preset;
	Transition t;
	PlaceList *ipl = (PlaceList*) NULL, *pl=PL_NULL;

        while ( ts != TS__NULL ) {
	      if ( is_postset(p, (t=ts->trans)) ) {
		  ts = ts->nexttrans; continue; }
              st = t->preset;
              while (st != ST__NULL) {
		    insert_pl(&pl, st->place);
                    st = st->nextplace;
                    }
              Intersect(&ipl, &pl);
	      if (ipl == PL_NULL) return(PL_NULL);
	      ts = ts->nexttrans;
              }
	return(ipl);
}
/*************************************************************************/
TransitionList *TPostset(Place p)
{
	STEdge st = p->postset;
	TSEdge ts;
	Transition t;
	TransitionList *tl = TL_NULL;

        while ( st != ST__NULL ) {
	      if ( is_preset(p, (t = st->trans)) ) {
		  st = st->nexttrans; continue; }
              ts = t->postset;
	      insert_tl( &tl, t );
	      st = st->nexttrans;
              }
	return(tl);
}
/*************************************************************************/
TransitionList *TPreset(Place p)
{
	STEdge st;
	TSEdge ts = p->preset;
	Transition t;
	TransitionList *tl=TL_NULL;

        while (ts != TS__NULL) {
	      if (is_postset(p,(t=ts->trans))) {
		  ts = ts->nexttrans; continue; }
              st = t->preset;
	      insert_tl(&tl, t);
	      ts = ts->nexttrans;
              }
	return(tl);
}
/*************************************************************************/
void Free_TList(TransitionList *tl)
{
	TransitionList *dtl;
	while (tl) { dtl=tl->next; free(tl); tl=dtl;}
}
/*************************************************************************/
void Free_PList(PlaceList *pl)
{
	PlaceList *dpl;
	while (pl) { dpl=pl->next; free(pl); pl=dpl;}
}
/*************************************************************************/
char Equal_TL(TransitionList *tlp, TransitionList *tlc)
{
	TransitionList *t1, *t2;
	char result;
	int tlplen = 0, tlclen = 0;

	t1 = tlp; while (t1) {tlplen++; t1 = t1->next;}
	t2 = tlc; while (t2) {tlclen++; t2 = t2->next;}
	if (tlclen != tlplen) return(0);
	t1=tlp;
	while (t1) {
	      result=0;
	      t2 = tlc;
	      while (t2) {
		    if (t1->t == t2->t) {result=1; break;}
		    t2 = t2->next;
		    }
              if (!result) return(0);
	      t1 = t1->next;
	      }
        return(result);
}
/*************************************************************************/
void Initialize_Net(LMPNet n)
{
	Place p;
	Transition t;
	TransitionList *tl, *tlist;
	PlaceList *pl, *plist;
	STEdge st;
	TSEdge ts;

	p = n->Places;
	while ( p ) {
		if ( p->label == ENTRY ) {
		     pl = plist = Real_PPostset(p);
		     while (pl) { pl->p->marks = 1; pl = pl->next;}
		     Free_PList(plist);
		     tl = tlist = Real_TPostset(p);
		     while ( tl ) { FREE_TR_ALL(tl->t);
			            delete_transition_direct(n, tl->t);
			            tl=tl->next; }
		     Free_TList(tlist);
		     FREE_PL_ALL(p);
		     delete_place_direct(n, p); }
                if ( p->label == EXIT ) {
		     tl = tlist = Real_TPreset(p);
		     while ( tl ) { FREE_TR_ALL(tl->t);
			            delete_transition_direct(n, tl->t);
			            tl=tl->next;}
		     Free_TList(tlist);
		     FREE_PL_ALL(p);
		     delete_place_direct(n, p); }
	        p = p->nextplace;
		}
}
/*************************************************************************/
char Post_of_Entry(Place p)
{
	STEdge st;
        TSEdge ts = p->preset;

 	while (ts != TS__NULL) {
              st = ts->trans->preset;
              while (st != ST__NULL) {
                    if (st->place->label == ENTRY) return(1);
                    st = st->nextplace;
                    }
              ts = ts->nexttrans;
              }
        return(0);
}
/*************************************************************************/
trans_PL *MakeTPL_GT(char *str)
{
	Place pl;
	PlaceList *pll = (PlaceList *) NULL, *ppll;
	trans_PL *tpl_new, *tplptr, *tplptr2;
	int placecounter=0, value, p_value, pos=0, j=0;
	char variable[MAXNAME], strval[MAXNAME];
	char *c, place_found=0, geq=0, pl_add;

	while ( str[pos] != '>' ) variable[j++] = str[pos++];
	variable[j++] = '=';
	variable[j] = '\0';
	j=0; pos++;
	if (str[pos] == '=') {pos++; geq=1;}
	while ( str[pos] != '\0' ) strval[j++] = str[pos++];
	strval[j] = '\0';
	mystr2int(strval, &value);

	pl = sysnet->Places;
	while ( pl != (Place) NULL ) {
	      if ( GET_PL_MEANING(pl) == (char *) NULL ) {
		   pl = pl->nextplace; continue; }
              if ( myindex( (c=GET_PL_MEANING(pl)), variable) < 0 ) {
		   pl = pl->nextplace; continue; }
              pos=j=0; 
	      place_found = 1;
	      while ( c[j++] != '=' ) ;
	      while ( c[j] != '\0' ) strval[pos++] = c[j++];
	      strval[pos] = '\0';
	      mystr2int(strval, &p_value);
	      pl_add=0;
	      if ( (! geq) && (p_value > value) ) pl_add = 1;
	      if ( (geq) && (p_value >= value) ) pl_add = 1;
	      if ( pl_add) { ppll = NEWPLIST;
			     ppll->p = pl;
		             ppll->next = pll;
		             pll = ppll;
		             placecounter++; }
              pl = pl->nextplace;
	      }
         if ( ! place_found ) {
	      printf("ERROR: Desired proposition \"%s\" : \n       ", str);
	      printf("No place with meaning %s=... in system net found!\n",str);
	      exit(1); }
         if (placecounter == 1) {
              tpl_new = NEW_TPL;
              tpl_new->op = Strdup( GET_PL_MEANING(pll->p) ) ;
              tpl_new->lop = tpl_new->rop = (trans_PL *) NULL;
              free(pll);
              return(tpl_new);
              }
         tpl_new = NEW_TPL;
         tpl_new->lop = tpl_new->rop = (trans_PL *) NULL;
         tpl_new->op = (char *) TPL_TRUE;
         while ( pll != (PlaceList *) NULL ) {
                 tplptr = NEW_TPL;
                 tplptr->lop = tplptr->rop = (trans_PL *) NULL;
                 tplptr->op = Strdup( GET_PL_MEANING(pll->p) );
                 tplptr2 = NEW_TPL;
                 tplptr2->lop = tplptr;
                 tplptr2->rop = tpl_new;
                 tplptr2->op = (char *) TPL_OR;
                 tpl_new = tplptr2;
                 ppll = pll->next; free(pll); pll = ppll;
                 }
	return(tpl_new);
}
/*************************************************************************/
trans_PL *MakeTPL_LT(char *str)
{
	Place pl;
	PlaceList *pll = (PlaceList *) NULL, *ppll;
	trans_PL *tpl_new, *tplptr, *tplptr2;
	int placecounter=0, value, p_value, pos=0, j=0;
	char variable[MAXNAME], strval[MAXNAME];
	char *c, place_found=0, leq=0, pl_add;

	while ( str[pos] != '<' ) variable[j++] = str[pos++];
	variable[j++] = '=';
	variable[j] = '\0';
	j=0; pos++;
	if (str[pos] == '=') {pos++; leq=1;}
	while ( str[pos] != '\0' ) strval[j++] = str[pos++];
	strval[j] = '\0';
	mystr2int(strval, &value);

	pl = sysnet->Places;
	while ( pl != (Place) NULL ) {
	      if ( GET_PL_MEANING(pl) == (char *) NULL ) {
		   pl = pl->nextplace; continue; }
              if ( myindex( (c=GET_PL_MEANING(pl)), variable) < 0 ) {
		   pl = pl->nextplace; continue; }
              pos=j=0;
	      place_found = 1;
	      while ( c[j++] != '=' ) ;
	      while ( c[j] != '\0' ) strval[pos++] = c[j++];
	      strval[pos] = '\0';
	      mystr2int(strval, &p_value);
	      pl_add = 0;
	      if ( (leq) && (p_value <= value) ) pl_add = 1;
	      if ( ( ! leq) && (p_value < value) ) pl_add = 1;
	      if ( pl_add ) { ppll = NEWPLIST;
		              ppll->p = pl;
		              ppll->next = pll;
		              pll = ppll;
		              placecounter++; }
              pl = pl->nextplace;
	      }
         if ( ! place_found ) {
	      printf("ERROR: Desired proposition %s : \n       ", str);
	      printf("No place with meaning %s=... in system net found!\n",str);
	      exit(1); }
         if (placecounter == 1) {
              tpl_new = NEW_TPL;
              tpl_new->op = Strdup( GET_PL_MEANING(pll->p) ) ;
              tpl_new->lop = tpl_new->rop = (trans_PL *) NULL;
              free(pll);
              return(tpl_new);
              }
         tpl_new = NEW_TPL;
         tpl_new->lop = tpl_new->rop = (trans_PL *) NULL;
         tpl_new->op = (char *) TPL_TRUE;
         while ( pll != (PlaceList *) NULL ) {
                 tplptr = NEW_TPL;
                 tplptr->lop = tplptr->rop = (trans_PL *) NULL;
                 tplptr->op = Strdup( GET_PL_MEANING(pll->p) );
                 tplptr2 = NEW_TPL;
                 tplptr2->lop = tplptr;
                 tplptr2->rop = tpl_new;
                 tplptr2->op = (char *) TPL_OR;
                 tpl_new = tplptr2;
                 ppll = pll->next; free(pll); pll = ppll;
                 }
	return(tpl_new);
}
/*************************************************************************/
Place RInsert_Place(LMPNet n, char *pname, Cardinal32 mark, Place *lp)
{
	Coords co;
	Place p;
	int s = sizeof(CoordEntry);
 
	p = fast_insert_place(n, pname, mark, lp);
	p->inscript = (char *) Malloc(s);
	co = (Coords) p->inscript;
	co->x = co->y = (int) NULL;
	co = co->next = (Coords) Malloc(s);
	co->x = co->y = (int) NULL;
	co = co->next = (Coords) Malloc(s);
	co->x = co->y = (int) NULL;
	co = co->next = (Coords) Malloc(s);
	co->x = co->y = (int) NULL;
	co = co->next = (Coords) Malloc(s);
	co->x = co->y = (int) NULL;
	co->next = (Coords) NULL;
	
	return(p);
}
/*************************************************************************/
Transition RInsert_Transition(LMPNet n, char *tname, Transition *lt)
{
	Coords co;
	Transition t;
	int s = sizeof(CoordEntry);

	t = fast_insert_transition(n, tname, lt);
	t->inscript = (char *) Malloc(s);
	co = (Coords) t->inscript;
	co->x = co->y = (int) NULL;
	co = co->next = (Coords) Malloc(s);
	co->x = co->y = (int) NULL;
	co = co->next = (Coords) Malloc(s);
	co->x = co->y = (int) NULL;
	co = co->next = (Coords) Malloc(s);
	co->x = co->y = (int) NULL;
	co->next = (Coords) NULL;

	return(t);
}
/*************************************************************************/
void  Free_Place_All(Place p)
{
	Coords co, co_del;

	co = (Coords) p->inscript;
        while ( co ) { co_del = co; 
                       co = co->next;
                       co_del->x = co_del->y = (int) NULL;
                       co_del->next = (Coords) NULL;
                       free(co_del); }
        p->inscript = (char *) NULL;
}
/*************************************************************************/
void  Free_Trans_All(Transition t)
{
	Coords co, co_del;

	co = (Coords) t->inscript;
        while ( co ) { 
		       co_del = co; 
                       co = co->next;
                       co_del->x = co_del->y = (int) NULL;
                       co_del->next = (Coords) NULL;
                       free(co_del); }
        t->inscript = (char *) NULL;
}
/*************************************************************************/
/*End of pf.c   */
/***********************/
