/*******************************************/
/* pf.h                   5.3.98           */
/* Frank Wallner                           */
/*******************************************/

#define NEWPLIST        (PlaceList *) MyMalloc(sizeof(PlaceList))
#define NEWTLIST        (TransitionList *) MyMalloc(sizeof(TransitionList))
#define P_NULL          (Place) NULL
#define T_NULL          (Transition) NULL
#define PL_NULL         (PlaceList *) NULL
#define TL_NULL         (TransitionList *) NULL
#define ST__NULL        (STEdge) NULL
#define TS__NULL        (TSEdge) NULL
#define FREE_TR_ALL(TR)		{ FREE_TR_ACTION_TERM( TR );\
				  FREE_TR_MEANING( TR );\
				  FREE_TR_VALUE_TERM( TR );\
				  FREE_TR_ANNOTATION( TR );\
				  FREE_TR_REFERENCE( TR );}
#define FREE_PL_ALL(PL)		{ FREE_PL_MEANING( PL );\
				  FREE_PL_REFERENCE( PL );\
				  FREE_PL_TYPE( PL );\
				  FREE_PL_IMARK_STR( PL );}


#define PROP_LENGTH	1000

/**************************/
/* Types                  */
/**************************/

typedef struct propo_ptr {  char prop_name[PROP_LENGTH];
                            char guard[PROP_LENGTH];
                           short nr;
                struct propo_ptr *next;
} propo_elm, *PROPO;


typedef struct {            char str[PROP_LENGTH];
                        trans_PL *tpl;
} EXPR_constr;


typedef struct _plist {  Place  p;
		 struct _plist  *next;
} PlaceList;


typedef struct _tlist {Transition  t;
		    struct _tlist  *next;
} TransitionList;



/****************/
/* VARIABLES    */
/****************/

extern unsigned int  file_changed;
extern        short  observed_places;
extern          int  _PBuechi_;
extern          int  _TBuechi_;
extern        PROPO  pro;
extern       LMPNet  bnet;
extern       LMPNet  sysnet;
extern        Place  syspl, bpl;
extern        Place  sys_dp, dp;
extern        Place  p_sf, p_ss;
extern   Transition  tr;
extern   Transition  sys_dt, dt;
extern       STEdge  sys_st, st;
extern       TSEdge  sys_ts, ts;
extern   Cardinal32  bpl_num, btr_num, spl_num, str_num; 
extern         char  phi[];
extern         char  to_prod;
extern         char  prod_formel[2000];
extern         char  **propositions;
extern     trans_PL  *tpl_new;
extern  BuechiTrans  *BTrans;
extern  BuechiTrans  *BTrans_new;
extern         char  CM_nettype[];
extern        short  bit_mask[];
extern         char  automaton[];
extern         char  LLautomaton[];
extern         char  sys_net[];
extern char is_preset(Place p, Transition t);
extern char is_postset(Place p, Transition t);
extern char is_looped(Place p, Transition t);
extern TransitionList** b_trans;

/***************************************************************************/

/* Functions used by the Parser */
/********************************/

         PROPO  find_prop_name (char *name);
         PROPO  find_guard (char *new_guard);
         PROPO  insert_prop (char *new_guard);
         short  max_used_prop ();
         Place  Find_P (LMPNet net, char *anno);
          void  create_transitions(LMPNet sn, LMPNet bn, /*char *guard,*/
                                   Place sdest, Place bdest,
                                   trans_PL *t);
          void  Make_Spinnever();
         Place  Insert_Place(LMPNet n, char *pname, Cardinal32 mark, Place *lp);
    Transition  Insert_Transition(LMPNet n, char *tname, Transition *lt);
        TSEdge  Insert_TP(LMPNet n, Place p, Transition t, Cardinal32 w, \
	                  Place *lp, Transition *lt, TSEdge *lts);
        STEdge  Insert_PT(LMPNet n, Place p, Transition t, Cardinal32 w, \
	                  Place *lp, Transition *lt, STEdge *lst);
          void  FreePlace(Place p);
          void  FreeTrans(Transition t);
          void  Create_Scheduler(int pn);
          void  determine_variable(char *s, char *t);
         Place  New_Place(LMPNet net, int num, Cardinal32 mark, Place *lp);
    Transition  New_Transition(LMPNet net, int num, Transition *lt);
         Place  RInsert_Place(LMPNet n, char *pname, Cardinal32 mark, Place *lp);
    Transition  RInsert_Transition(LMPNet n, char *tname, Transition *lt);
          void  Free_Place_All(Place p);
          void  Free_Trans_All(Transition t);


/* Functions used by the Annotation-Procedure */
/**********************************************/

     PlaceList  *insert_pl(PlaceList **pl, Place p);
TransitionList  *insert_tl(TransitionList **tl, Transition t);
          void  Free_TList(TransitionList *tl);
          void  Free_PList(PlaceList *pl);
          void  Intersect(PlaceList **ipl, PlaceList **pl);
     PlaceList  *Real_PPostset(Place p);
     PlaceList  *Real_PPreset(Place p);
TransitionList  *Real_TPostset(Place p);
TransitionList  *Real_TPreset(Place p);
     PlaceList  *PPostset(Place p);
     PlaceList  *PPreset(Place p);
TransitionList  *TPostset(Place p);
TransitionList  *TPreset(Place p);
         Place  Complement_Place(Place p);
         Place  Create_Complement(LMPNet *n,char *vn,int pn,Place p);
          char  Equal_TL(TransitionList *tlp, TransitionList *tlc);
	  void  Initialize_Net(LMPNet n);
          char  Post_of_Entry(Place p);
      trans_PL  *MakeTPL_GT(char *str);
      trans_PL  *MakeTPL_LT(char *str);

/********************************/
/* End of File pf.h             */
/********************************/

