/******************************************************/
/* check.c                                            */
/* main-function for checking LTL-properties of       */
/* net systems                                        */
/* Frank Wallner, Feb. 97                             */
/* revision April 98                                  */
/******************************************************/

#include "qq_header.h"

#define UNFOLD	"ERVunfold"
#define PROGRESS " -q "

/**********************/
/* Global variables   */
/**********************/
FILE 	*fff;
FILE  		*F_OUT;			/*file for stdout                     */
FILE 		*fres;  		/*contains the accepting scc's        */
LMPNet		sysnet;			/*System net                          */
Event 		*ep;         		/*Global pointer to events/nodes      */
Event		*events;	   	/*pointer to events of the prefix     */
Node 		*buechi_nodes;     	/*pointer to nodes in BuechiGraph     */
int             *place_num,             /*Numname of the place of a cond.     */
		*condition,             /*condition[j]=k means P_j = \pi(B_k) */
		*pre_trans;             /*one place_numname of \pre(t)        */
PNames          *pnames;		/*pnames[i] = Place_i->name in Sys    */
TNames          *tnames;                /*tnames[i] = Trans_i->name in Sys    */
TE_List         **b_post = (TE_List **) NULL;
					/*events in postset of conditions     */
TE_List        	**enCorrs = (TE_List **) NULL;
					/*hash-table for corrs of ENodes      */
BuechiTrans 	*BTrans = (BuechiTrans *) NULL;
           	 		   	/*ptr to buechitrans's list           */
ConfS           conf1,conf2,conf3,conf4; /*Configurations (bitarrays)         */
CutS       	cut1, cut2, cut3;	/*Cuts (bitarrays)                    */
BitArray 	bitmask[BA_BASE];	/*for manipulating the BitArrays      */
int 		*stack,            	/*for Tarjan's algor                  */
 		stackpointer,      	/*for Tarjan's algor                  */
		count,             	/*counter for strongly conn comps     */
 		*b_stack,            	/*for Tarjan's algor (buechi-circle)  */
 		b_stackpointer,      	/*for Tarjan's algor (buechi-circle)  */
		b_count,             	/*counter for scc in b_search         */
		EN_idx=0,		/*idx of ENodes (of next new ENode)   */
		locEN=0,		/*ctr of local corrs of ENodes        */
		globEN=0,		/*ctr of global corrs of ENodes       */
		globEN_nc=0,		/*ctr of  --"-- without    Corr event */
		component,         	/*counter for sccs of several nodes   */
		comp_ctr = 1,         	/*counter for _all_ sccs              */
		acc_ctr = 1,         	/*counter for accepting sccs          */
		aut_acc_ctr = 1,        /*counter for automaton accepting sccs*/
		ffcomp1=0, ffcomp2=0,  	/*counter for _all_ sccs              */
		ffacc1=0, ffacc2=0,    	/*counter for accepting sccs          */
		fncomp1=0, fncomp2=0,   /*counter for non_buechi sccs         */
		fnacc1=0, fnacc2=0,     /*counter for acc. non_buechi sccs    */
                _TBuechi_ = 0,          /*number of Buechi Transitions        */
                _PBuechi_ = 0,          /*number of Buechi Places             */
		E_Fin,      		/*number of events of the prefix      */
            	B_Fin,		   	/* ... *used* conditions in prefix    */
					/* i.e. except postconds of cutoffs   */
		real_B_Fin,		/* *all* conditions in the prefix     */
		E_off=0,           	/*number of cut-off events            */
		E_corr=0,       /*number of corresponding events      */
		actual_buechi,		/*current initial state for b_search  */
                initial_state = 0,      /*real init. state of A_f             */
		*cutofflist,            /*list of cutoff-events               */
		*corrlist;              /*list of corresponding events        */
short 		observed_places; 	/*number of observed places           */
char 		result_SCCs[MAXCHAR], 	/*FileName of fres                   */
                automaton[MAXCHAR],	/*FileNames of the automaton (spin)   */
		LLautomaton[MAXCHAR],   /*                           (LL-Net) */
		unfolding[MAXCHAR],     /*             the unfolding          */
		incomplCtrEx[MAXCHAR],  /*             the counterexample     */
		sys_net[MAXCHAR],       /*             the System-(LL)-Net    */
		syncllnet[MAXCHAR],	/*             the synchronized Net   */
 		prod_formel[2000], 	/*string for PROD-formula             */
		accepting_component=0,  /* 0 = false, 1 = true                */
                initialize_net=0,       /* flag: initialize the variables?    */
		incomplete=0,  		/* flag: find ctrex during unf. proc. */
		to_prod=0,  		/* flag: translation to PROD          */
                all_counterexamples=0,  /* flag: find all counterexamples?    */
                good_counterexample=1,  /* flag: find "good" counterexample?  */
                extended_output=0,      /* flag: long/short info in scc-file? */
                use_unf=0,              /* flag: use already computed unf     */
                print_automaton=1,      /* flag: print the f.automaton?       */
                print_aut_as_ll=0,    	/* flag: print the autom. as ll-Net?  */
       		show_statistics=0,	/* flag: print some statistics ?      */
                no_output=0,    	/* flag: print evolution of progress? */
                final_result=0,		/* falsity of f already proved?       */
                alreadyNO=0,		/* falsity of f already printed?      */
		stopaftersync=0;	/* stop after synchronisation	      */
char		**propositions;	   	/* array of atomic propositions       */
char            *current_marking;       /*marking of observed places (Phase2) */
SetS            corr_conf,              /*set of corresponding events         */
		buechi_conf,            /*set of buechi-events                */
		final_conf,             /*set of accepting events             */
		vis_conf;               /*set of visible events               */
int	        maxcorr=0,		/*max. corresponding event            */
 		_P_sys,                 /* for Statistics:                    */
                _T_sys,
                _P_init,
                _T_init,
                _P_sync,
                _T_sync;
Int_List      	*Accept_all_List;	/*list of 'accept_all'- Places        */
float		all_time_f,  		/*for time measurements               */
		unf_time_f, 
		sync_time_f;
etime_t		all_time, unf_time, sync_time;
int 		stdout_fd;		/*for silent computation              */

/******************************************************************************/
main(int argc, char **argv)
{

/*******************/
/* local variables */
/*******************/

char 		line[MAXLINE];               /* string read from files        */
int  		len,                         /*length of some strings         */
		j,k,
		*h = (int *) NULL;
FILE 		*F_unf;                      /*contains the unfolding-File    */
FILE 		*F_ctrex;                    /*counterexample   (incomplete)  */
register int 	i;
char  		show_progress=0,        /* flag: show progress of unfolding?  */
		show_extension=0,       /* flag: show progr. of G-Extension?  */
		from_prod=0,		/* flag: translation?                 */
	        use_ERV=1;		/* flag: default=use ERV-Algor.       */
Place		place;
Transition 	trans;
STEdge 		st;
BitArray        barr=1;
Int_List   	*loc_ENcorrs, *glob_ENcorrs, *iln;
ENode 		*en;
TE_List 	*tel;
time_t          *tloc;

/******************************************************************************/



/********/
/* main */
/********/

#ifdef YYDEBUG
{
	extern int yydebug;
	yydebug = 1;
}
#endif

   all_time = nc_startclock();

   if ((argc == 2) && strcmp(argv[1],"-y")==0) { Print_LTL_Syntax(); exit(0); }
   if ( argc < 3 ) { Print_Usage(argv[0]); exit(0); }

   if ( (i=myindex(argv[1],".ll_net")) ) (argv[1])[i] = '\0';
   if ( argv[2][0] != '-' ) j=3; else j=2;
   for ( k=j; k<argc; k++ ) {
   	strcpy(line, argv[argc-1]);
   	if ( line[0] != '-' ) { printf("ERROR: %s.main(): %s ?? \ninput file(s) already specified;\noptions must start with '-'\n\n", argv[0], line); exit(1); }
      	for (i=1; line[i] != '\0'; i++) {
            if (line[i] == 'b') {incomplete=1; continue;}
            if (line[i] == 'c') {all_counterexamples=1; continue;}
	    if (line[i] == 'i') {initialize_net=1; continue;}
            if (line[i] == 'm') {use_ERV=0; continue;}
            if (line[i] == 'p') {show_progress=1; continue;}
            if (line[i] == 'g') {show_extension=1; continue;}
            if (line[i] == 'q') {no_output=1; continue;}
            if (line[i] == 'f') {good_counterexample=0; continue;}
            if (line[i] == 'u') {use_unf=1; continue;}
	    if (line[i] == 's') {show_statistics=1; continue;}
	    if (line[i] == 'P') {to_prod=1; continue;}
	    if (line[i] == 'F') {from_prod=1; continue;}
	    if (line[i] == 'C') {Clean_Up(argv[1], argv[2], argv[0]); exit(0); }
            if (line[i] == 'A') {print_automaton=0; continue;}
            if (line[i] == 'L') {print_aut_as_ll=1; continue;}
            if (line[i] == 'x') {extended_output=1; continue;}
            if (line[i] == 'S') {stopaftersync=1; continue;}
 
	    /* else */
            printf("Oha... illegal option -%c .\nType \"%s\" to get a short description of %s.\n", line[i], argv[0], argv[0]);
            exit(1);
            }
        }

   if ( no_output ) {
	show_progress = 0;
	strcpy(line,argv[1]); strcat(line,".out");
	stdout_fd = dup(stdout->_file);
	F_OUT = freopen(line, "at", stdout); 
        tloc = (time_t *) MyMalloc(sizeof(time_t));
        time(tloc);
	cftime(line, "%C", tloc);
	free(tloc);
 	printf("\n\n\n************** %s *****************\n", line);
	printf("arguments: ");
	i=1; while (i<argc) printf("%s ", argv[i++]);
	printf("\n");
	}

   if ( all_counterexamples && (! good_counterexample) ) {
      printf("WARNING: flags -c and -f are set. ;-)\n-c is used ...\n\n");
      good_counterexample = 1; }
   if ( all_counterexamples && incomplete ) {
      printf("WARNING: flags -b and -c are set. ;-)\n-b is used ...\n\n");
      all_counterexamples = 0; }
   if ( use_unf && incomplete ) {
      printf("Flags -u and -b together are not possible.\n");
      printf("-b is used ...\n\n"); 
      use_unf = 0; }

   strcpy(sys_net,argv[1]);             strcat(sys_net,".ll_net");
   strcpy(unfolding,argv[1]);        	strcat(unfolding,".unf");
   strcpy(syncllnet,argv[1]);        	strcat(syncllnet,".sync.ll_net");
   strcpy(result_SCCs,argv[1]);          	strcat(result_SCCs,".scc");
   strcpy(incomplCtrEx,argv[1]);        strcat(incomplCtrEx,".ctrex");

   if (j == 3) {
       strcpy(LLautomaton, argv[2]);	strcat(LLautomaton,".aut.ll_net");
       strcpy(automaton, argv[2]);	strcat(automaton,".aut"); }

   if (to_prod) { strcpy(result_SCCs,argv[1]); strcat(result_SCCs,".net"); }
   if (from_prod) { strcpy(result_SCCs,argv[1]); 
                    if (myindex(result_SCCs, ".net") < 0 ) strcat(result_SCCs,".net"); }

   if (j == 2) if (! to_prod && ! from_prod) {
       printf("ERROR: %s.main(): <property> not specified\nType '%s' to get a short description.\n", argv[0], argv[0]); exit(1); }

   /*** Initialize the BitArray Base (bitmask) ***/ 
   for (i=BA_BASE-1; i>=0; i--) { bitmask[i]=barr; barr *= 2; }

   /*** Initialize the Accept_all-List ***/
   Accept_all_List = IL_NULL;

   /*** read_net && write_net - Parameters ***/
   CM_storeMeaning = CM_storeCoordinates = True; 
   strcpy(CM_nettype, "PTNet");

/*********************** Translation from/to PROD  ****************************/
   if ( to_prod ) { 
       prod_formel[0] = '\0';
       sysnet = read_new_PEP(sys_net);
       num_net_nodes(sysnet);
       _P_sys = sysnet->LastPlace->numname;
       _T_sys = sysnet->LastTransition->numname;
       fres = FileOpen(result_SCCs, "w");
       if (initialize_net) { Initialize_Net(sysnet);
                             num_net_nodes(sysnet);
                             _P_init = sysnet->LastPlace->numname;
                             _T_init = sysnet->LastTransition->numname;
	                     line[0] = '\0';
	                     sprintf(line, "%s.init.ll_net", argv[1]);
	                     write_new_PEP(sysnet, line); }
       observed_places = 0; 
       if (j == 3) { /* formula specified */
           yyin = FileOpen(argv[2], "r"); yyparse();
           observed_places = max_used_obs(&observer);
	   }
       Translate_to_Prod(fres, argv[0]);
       fclose(fres);
       if ( show_statistics ) {
            printf("%s:      ", sys_net);
            printf("|P| = %5d ", _P_sys); 
            printf("|T| = %5d \n", _T_sys); 
            if (initialize_net) { 
                for (i=0; i<strlen(sys_net); i++) printf(" ");          
                printf("      ");
                printf("(|P| = %5d ", _P_init); 
                printf("|T| = %5d ", _T_init); 
                printf("w/ initialised variables)\n"); 
                printf("initialised net "); } 
            printf("written to %s\n\n", result_SCCs);
            }
        if ( no_output ) { fclose(F_OUT); fdopen(stdout_fd, "a"); }
        exit(0);
        }

   if ( from_prod ) { 
       fres = FileOpen(result_SCCs, "r");
       j = (int) Translate_from_Prod(fres, argv[0]);
       fclose(fres);
       if ( j == 1 ) { fclose(fres); exit(1); } 
       if ( j == 2 ) { 
            printf("Probably the net '%s' is not 1-safe.\n", result_SCCs); 
            fclose(fres); 
            if ( no_output ) { fclose(F_OUT); fdopen(stdout_fd, "a"); }
	    exit(1); } 
       _P_sys = sysnet->LastPlace->numname;
       _T_sys = sysnet->LastTransition->numname;
       num_net_nodes(sysnet);
       write_new_PEP(sysnet, sys_net);
       if ( show_statistics ) {
            printf("%s:      ", sys_net);
            printf("|P| = %5d ", _P_sys); 
            printf("|T| = %5d \n", _T_sys); 
            printf("read from %s\n\n", result_SCCs);
            }
        if ( no_output ) { fclose(F_OUT); fdopen(stdout_fd, "a"); }
        exit(0);
        }


/**************************** MODEL CHECKER ***********************************/

   printf("Transformation of formula ........ "); fflush(stdout); 
   /************************************************************/
   sync_time = nc_startclock();
   sysnet = read_new_PEP(sys_net);
   num_net_nodes(sysnet);
   _P_sys = sysnet->LastPlace->numname;
   _T_sys = sysnet->LastTransition->numname;
   if ( initialize_net ) { Initialize_Net(sysnet);
			   num_net_nodes(sysnet);
                           _P_init = ( PlaceCount(sysnet) - _PBuechi_ ); 
                           _T_init = ( TransCount(sysnet) - _TBuechi_ ); 
			   line[0]='\0';
			   sprintf(line, "%s.init.ll_net", argv[1]);
			   write_new_PEP(sysnet, line); }
   yyin = FileOpen(argv[2], "r");
   yyparse(); printf("OK.\n");


   printf("Synchronization .................. "); fflush(stdout); 
   /*************************************************************/
   observed_places = max_used_obs(&observer);
   Synchronize_Net(syncllnet, propositions, observed_places);
   remove_obs(&observer);
   current_marking = (char *) MyMalloc(observed_places * sizeof(char));
   sync_time_f = nc_stopclock(sync_time); printf("OK.\n");

   if (stopaftersync) exit(0);
 

   if ( ! use_unf ) {
        printf("Building the Finite Prefix ....... "); fflush(stdout); 
        /************************************************************/
        strcpy(line, "");
        if ( incomplete ) 
	     sprintf(line, "%s -u=%s -c %s -V=%s", UNFOLD, unfolding, 
						   syncllnet, incomplCtrEx);
        else sprintf(line, "%s -u=%s -c %s", UNFOLD, unfolding, syncllnet);
        if ( use_ERV ) strcat(line," -@ ");
        if ( show_progress ) { strcat(line, PROGRESS); printf("\n"); }
        unf_time = nc_startclock();
        if ( system(line) ) {
	     printf("Oha... EVunfold not successful.\n"); 
             if (no_output) { fclose(F_OUT); fdopen(stdout_fd,"a"); }
             exit(1);
	     }
        unf_time_f = nc_stopclock(unf_time);
        }
   strcpy(line, "");
   if ( incomplete ) {
	if ( Print_CounterExamples() ) {
	     all_time_f = nc_stopclock(all_time);
	     if ( show_statistics ) ShowStatistics();
             if ( no_output ) { EXIT_NO_OUTPUT; }
	     exit(0);
             }
        }
   if ( ! use_unf ) printf("OK.\n"); 


   /**************************************/
   /* model checking procedure           */
   /**************************************/

   /* Read the events,conditions, and Buechi-Information */
   /******************************************************/
   printf("Read unfolding information ....... ");fflush(stdout); 
   sysnet = read_new_PEP(syncllnet);
   num_net_nodes(sysnet);
   _P_sync = sysnet->LastPlace->numname;
   _T_sync = sysnet->LastTransition->numname;
   pnames = (PNames *) MyMalloc( sizeof(PNames) * _P_sync );
   tnames = (TNames *) MyMalloc( sizeof(TNames) * (_T_sync + 1) );
   pre_trans = (int *) MyMalloc( sizeof(int) * (_T_sync + 1) );
   place = sysnet->Places;
   while ( place ) { pnames[(place->numname)-1] = Strdup(place->name); 
                     place = place->nextplace; }
   trans = sysnet->Transitions;
   while ( trans ) { st = trans->preset; 
	             pre_trans[trans->numname] = st->place->numname; 
                     tnames[(trans->numname)-1] = Strdup(trans->name); 
                     trans = trans->nexttrans; }
   tnames[_T_sync] = Strdup("");
   /***************************************************/
   F_unf = FileOpen(unfolding, "r"); 
   j = GetEvents(F_unf, &ep, &B_Fin, &E_Fin);
   fclose(F_unf);
   /***************************************************/
   place = sysnet->Places;
   trans = sysnet->Transitions;
   while (place) {Free_Place_All(place); place = place->nextplace;}
   while (trans) {Free_Trans_All(trans); trans = trans->nexttrans;}
   remove_net(&sysnet);
   printf("OK.\n");


   /* check if an "accept_all"-place is contained in the prefix */
   /*************************************************************/
   if ( j == 0 ) { /* GetEvents detected accept_all events */
       fres = FileOpen(result_SCCs,"w"); 
       for ( i=0; i<=E_Fin; i++ ) {
             if ( INFO(i) != IMMEDIATE_STOP ) continue;
             if ( ! alreadyNO ) { printf("\n\nNO.\n\n"); alreadyNO = 1; }
	     InitConfig( i );
             if ( ! all_counterexamples ) { Print_AcceptAll(stdout,i);
                                            alreadyNO = 1;
                                            break;}
             if ( ! alreadyNO ) { 
                  fprintf(fres, "\"Accept_all\" place reachable!\n");
                  fprintf(fres, "*****************************\n\n");
	          alreadyNO = 1; }
             Print_AcceptAll( fres, i ); 
	     }
       if ( alreadyNO ) {
            if ( all_counterexamples ) {
	         printf("** Counterexamples in File %s **\n", result_SCCs);
	         fclose(fres); }
	    all_time_f = nc_stopclock(all_time);
            if ( show_statistics ) ShowStatistics();
            if ( no_output ) { EXIT_NO_OUTPUT; }
            exit(0); 
            }
       } /* GetEvents detected accept_all events */
   /****************************************************************/


   /* Get Memory for Configurations, Cuts, stack, and Buechi-Graph */
   /****************************************************************/
   i = ( (E_Fin/BA_BASE) + 2 ) * BA_SZ;
   conf1 = ( ConfS ) MyMalloc(i);
   conf2 = ( ConfS ) MyMalloc(i);
   conf3 = ( ConfS ) MyMalloc(i);
   conf4 = ( ConfS ) MyMalloc(i);
   corr_conf = ( SetS ) MyMalloc(i);
   buechi_conf = ( SetS ) MyMalloc(i);
   final_conf = ( SetS ) MyMalloc(i);
   vis_conf = ( SetS ) MyMalloc(i);
   
   i = ( (B_Fin/BA_BASE) + 2 ) * BA_SZ;
   cut1 = ( CutS ) MyMalloc(i);
   cut2 = ( CutS ) MyMalloc(i);
   cut3 = ( CutS ) MyMalloc(i);
   cut1[(B_Fin/BA_BASE)+1]=cut2[(B_Fin/BA_BASE)+1]=cut3[(B_Fin/BA_BASE)+1]=BA_ALL;
   condition = (int *) MyMalloc(sizeof(int) * (1+_P_sync));
   
   stack = (int *) MyMalloc( E_corr * sizeof(int) );
   b_stack = (int *) MyMalloc( _PBuechi_ * sizeof(int) );
   
   events = ep;
   ep = ((Event*) buechi_nodes) = (Node*) calloc( _PBuechi_, sizeof(Node) );
   Initialize_Buechi_Nodes();
   ep = events;
   cutofflist = (int *) MyMalloc(E_off * sizeof(int));
   corrlist = (int *) MyMalloc(E_corr * sizeof(int));
   fres = FileOpen(result_SCCs,"w"); 

   i = ( E_Fin / BA_BASE );
   for (j=0; j<=i; j++) 
        buechi_conf[j] = final_conf[j] = corr_conf[j] = vis_conf[j] = 0;
   corr_conf[(i+1)] = 0;
   buechi_conf[(i+1)] = 0;
   final_conf[(i+1)] = 0;
   vis_conf[(i+1)] = 0;
   /* Initialize the Sets of events ... */
   j = k = 0;  
   for ( i=0; i<=E_Fin; i++ ) {
       if ( IS(CORR,i) )  { corr_conf[(i/BA_BASE)] |= bitmask[(i%BA_BASE)]; 
                            corrlist[k++] = i; len = 1;
			    while ( len <= cutoff_quantity(i) ) 
				    cutofflist[j++] = cutoff_num(i, len++);
			  }
       if (IS(FINAL,i))   { final_conf[(i/BA_BASE)]  |= bitmask[(i%BA_BASE)]; }
       if (IS(BUECHI,i))  { buechi_conf[(i/BA_BASE)] |= bitmask[(i%BA_BASE)]; }
       if (IS(VISIBLE,i)) { vis_conf[(i/BA_BASE)]    |= bitmask[(i%BA_BASE)]; }
       }



   j = ( E_off + E_corr );
   printf("Creating graph (%6d) ...", j); fflush(stdout);
   /***********************************************************/
   if ( no_output || (! show_extension) ) {
      for (i = 0 ; i<E_off; i++, j--) { 
           if ( (k = ADJ_Cutoff(cutofflist[i])) ) {
		final_result = 1;
	        if ( all_counterexamples ) continue;
                if ( (k==1) && good_counterexample ) continue;
	        all_time_f = nc_stopclock(all_time);
                if ( show_statistics ) ShowStatistics();
                fclose(fres); 
	        if ( no_output) { EXIT_NO_OUTPUT; }
	        exit(0);
                }
           }
      for (i = 0 ; i<E_corr; i++, j--)  { k = 0;
	   if ( ! IS(VISITED, corrlist[i]) ) ADJ_Corr(corrlist[i]);
           if ( (k = Check_Corr_Cycles(corrlist[i]))  ) {
		final_result = 1;
	        if ( all_counterexamples ) continue;
                if ( (k==1) && good_counterexample ) continue;
	        all_time_f = nc_stopclock(all_time);
                if ( show_statistics ) ShowStatistics();
                fclose(fres); 
	        if ( no_output) { EXIT_NO_OUTPUT; }
	        exit(0);
                }
	   }
      printf("....... OK.\n");
      }
   else { /* count the computed CutOffs */
      printf("       ");
      for (i = 0 ; i<E_off; i++, j--) { 
	   if ( (j%20) == 0 ) { printf("\b\b\b\b\b\b%6d",j); fflush(stdout); }
           if ( (k = ADJ_Cutoff(cutofflist[i])) ) {
		final_result = 1;
	        if ( all_counterexamples ) continue;
                if ( (k==1) && good_counterexample) continue;
	        all_time_f = nc_stopclock(all_time);
                if ( show_statistics ) ShowStatistics();
                fclose(fres); 
	        exit(0);
                }
           }
      for (i = 0 ; i<E_corr; i++, j--)  { k = 0;
	   if ((j%20) == 0) { printf("\b\b\b\b\b\b%6d",j); fflush(stdout); }
	   if ( ! IS(VISITED, corrlist[i]) ) ADJ_Corr(corrlist[i]);
           if ( (k = Check_Corr_Cycles(corrlist[i]))  ) {
		final_result = 1;
	        if ( all_counterexamples ) continue;
                if ( (k==1) && good_counterexample ) continue;
	        all_time_f = nc_stopclock(all_time);
                if ( show_statistics ) ShowStatistics();
                fclose(fres); 
	        exit(0);
                }
	   }
      printf("\b\b\b\b\b\b\b....... OK.\n");
      }
   /* graph is created */




   printf("Searching graph .................. "); fflush(stdout);
   /*************************************************************/

   /* search strongly connected components */
   /****************************************/
   /* Initialize the Nodes and the stack-info*/
   for (i=0; i<E_off; i++) {
        k = cutofflist[i];
        if ( k != representative(k) ) { INFO(k) |= VISITED; continue; }
        INFO( k ) &= (~ONSTACK); 
        INFO( k ) &= (~VISITED); 
        dfn(k) = lowlink(k) = scc(k) = scc_idx(k) = 0;
        }
   b_stackpointer = stackpointer = accepting_component = acc_ctr = 0;
   count = component = comp_ctr = 1;

   /* while there exists an event v that is not visited do search(v) */
   for ( i=0; i < E_off; i++ ) {
	 k = cutofflist[i];
	 if ( ! IS(VISITED,k) ) { final_search(k); }
	 if ( all_counterexamples ) continue;
	 if ( alreadyNO && show_statistics ) {
	      all_time_f = nc_stopclock(all_time);
	      ShowStatistics();
              ffcomp1 = comp_ctr - 1;
              ffacc1 = acc_ctr;
              fclose(fres); 
              if ( no_output ) { EXIT_NO_OUTPUT; }
	      exit(0); }
	 }
   ffcomp1 = comp_ctr - 1;
   ffacc1 = acc_ctr;

    
   /* search strongly connected components without any Buechi */
   /***********************************************************/
   /* Initialize the Nodes and the stack-info*/
   for (i=0; i<E_off; i++) {
        k = cutofflist[i];
        if ( k != representative(k) ) { INFO(k) |= VISITED; continue; }
        INFO( k ) &= ((~ONSTACK) & (~VISITED)); 
        dfn(k) = lowlink(k) = scc(k) = scc_idx(k) = 0;
        }
   b_stackpointer = stackpointer = accepting_component = acc_ctr = 0;
   count = component = comp_ctr = 1;

   /* while there exists an event v that is not visited do search(v) */
   for (i=0; i<E_off; i++) {
        if ( aut_acc_ctr > MAX2_COUNTEREXAMPLES ) { break; }
        if (! IS(VISITED, cutofflist[i])) { non_final_search(cutofflist[i]); }
	if ( good_counterexample ) continue;
	if ( alreadyNO && show_statistics ) {
	     all_time_f = nc_stopclock(all_time);
             fnacc1 = acc_ctr;
             fncomp1 = comp_ctr - 1;
	     ShowStatistics();
             fclose(fres); 
             if ( no_output ) { EXIT_NO_OUTPUT; }
	     exit(0); }
	}
   if ( ! alreadyNO ) printf("OK.\n");
   fnacc1 = acc_ctr;
   fncomp1 = comp_ctr - 1;

   if (final_result && (! all_counterexamples) ) {
       fclose(fres);
       if (! alreadyNO ) 
            printf("\nNO.\n\n** Counterexamples in file %s **\n", result_SCCs);
       else printf("\n** Counterexamples in file %s **\n\n", result_SCCs);
       all_time_f = nc_stopclock(all_time);
       if (show_statistics) ShowStatistics();
       if ( no_output ) { EXIT_NO_OUTPUT; }
       exit(0);
       }


   /*******************************************/
   /* including some global configurations    */
   /*******************************************/

   /* Read some conflict info */
   /***************************/
   free(b_post);
   b_post = (TE_List **) MyMalloc( (B_Fin + 1)* sizeof(TE_List *) );
   F_unf = FileOpen(unfolding, "r");
   ReadConflicts(F_unf);
   fclose(F_unf);
   printf("Computing some conflict info ..... "); fflush(stdout);
   /*********************************************************************/
   if ( IS(CORR,0) ) j=1; else j=0; 
   for ( i=j; i < E_corr; i++) {
	 k = corrlist[i];
	 Make_Conflict( k );
	 INFO(k) &= ~VISITED;
	 __lastEdge(k) = (int) __adjacents(k);
	 nextcorrs(k) = (int) NextCorrList(k); }
   printf("OK.\n");
   
   printf("Extending graph (%6d) .........", E_off); fflush(stdout);
   /******************************************************************/
   /* compute the ENodes of any concurrent pair of corr and cutoff */
   for (i=0; i<E_corr; i++) INFO(corrlist[i]) &= ~(VISITED); 
   j = 0;
   enCorrs = (TE_List **) MyMalloc( sizeof(TE_List *) * (E_Fin/__HT__) );
   if ( no_output || ( ! show_extension) ) {
	  for ( i=0; i<E_off; i++ ) { ADJ_co(cutofflist[i]); }
	  }
   else { for ( i=0; i<E_off; i++ ) {
              if ((i%20) == 0) { printf("\b\b\b\b\b%5d",i); fflush(stdout); }
	      ADJ_co(cutofflist[i]); }
          printf("\b\b\b\b\b%5d", i); fflush(stdout);
        }

   /* compute the ENodes of the ENcorrs and cutoffs */
   while ( (globEN + locEN) > 0 ) {
         iln = loc_ENcorrs = glob_ENcorrs = IL_NULL;
	 tel = (TE_List *) NULL;
	 if ( locEN ) {
              for ( i=0; i<=E_Fin; i++ ) {
	          if ( IS(CORR,i) ) { lastENode(i) = enodes(i); continue; }
	          if ( IS(CUTOFF,i) || ( ! ip_mem(i) ) ) continue;
		  if ( IS( ONSTACK,i ) ) continue;
		  INFO(i) |= (ONSTACK);
	          iln = NEW_INTLIST; 
	          iln->next = loc_ENcorrs; iln->i = i; loc_ENcorrs = iln;
		  if ( maxCorr(i) ) 
		       S_lastENode(i) = (int) enodes(maxCorr(i));
		  else S_lastENode(i) = 0; 
		  }
	      }
         globEN = 0;
	 Create_Cand_Lists( &glob_ENcorrs );
	 if ( show_extension ) {
              printf("  new: %5d(loc) %5d(glob)\n", locEN, (globEN+globEN_nc));
              printf("Extending graph (%6d) ........ ", E_off); 
	      fflush(stdout); }
	 locEN = globEN = globEN_nc = 0;
         if ( no_output || (! show_extension) ) {
	      for ( i=0; i < E_off; i++ ) {
	          ADJ_co2(cutofflist[i], loc_ENcorrs, glob_ENcorrs); }
	      }
         else {
              for ( i=0; i < E_off; i++ ) {
                  if ((i%20) == 0) {printf("\b\b\b\b\b%5d",i); fflush(stdout);}
	          ADJ_co2(cutofflist[i], loc_ENcorrs, glob_ENcorrs);
		  }
              printf("\b\b\b\b\b%5d",i); fflush(stdout);
              }
         Free_Int_List(loc_ENcorrs);
         Free_Int_List(glob_ENcorrs);
	 }
   if ( ! show_extension ) printf(" OK.");

   /* Extended Search: strongly connected components */
   /**************************************************/
   Init_Extended_Search();

   printf("\nSearching graph again ............ "); fflush(stdout);
   /**************************************************************/
   fprintf(fres,"\n\n****Included Global States ****\n\n");
       
   /* while there exists an event v that is not visited do search(v) */
   for ( i=0; i <E_off;  i++ ) {
	 k = cutofflist[i];
	 if ( ! IS(VISITED,k) ) { X_final_search(k); }
	 if ( all_counterexamples ) continue;
	 if ( alreadyNO && show_statistics ) {
	      all_time_f = nc_stopclock(all_time);
              ffcomp2 = comp_ctr - 1;
              ffacc2 = acc_ctr;
	      ShowStatistics();
              fclose(fres); 
              if ( no_output ) { EXIT_NO_OUTPUT; }
	      exit(0);
	      }
	 }
   for ( i=0; i <= E_Fin; i++ ) {
	 if ( ! ip_mem(i) ) continue;
	 if ( IS(VISITED, i) ) continue;
	 en = (ENode *) enodes(i);
	 while ( en ) { 
		EN_final_search( en ); 
		en = en->next;
	        if ( all_counterexamples ) continue; 
	        if ( alreadyNO && show_statistics ) {
	             all_time_f = nc_stopclock(all_time);
                     ffcomp2 = comp_ctr - 1;
                     ffacc2 = acc_ctr;
	             ShowStatistics();
                     fclose(fres); 
                     if ( no_output ) { EXIT_NO_OUTPUT; }
	             exit(0);}
		}
	 }
   ffcomp2 = comp_ctr - 1;
   ffacc2 = acc_ctr;


   /* search for cycles without Buechi-transition */
   Init_Extended_Search();

   /* while there exists an event v that is not visited do search(v) */
   for ( i=0; i < E_off; i++ ) {
         if ( aut_acc_ctr > MAX2_COUNTEREXAMPLES ) { break; }
	 k = cutofflist[i];
	 if ( ! IS(VISITED,k) ) { X_non_final_search(k); }
	 if ( all_counterexamples ) continue;
	 if ( alreadyNO && show_statistics ) {
	      all_time_f = nc_stopclock(all_time);
              fncomp2 = comp_ctr - 1;
              fnacc2 = acc_ctr;
	      ShowStatistics();
              fclose(fres); 
              if ( no_output ) { EXIT_NO_OUTPUT; }
	      exit(0);
	      }
	 }
   for ( i=0; i <= E_Fin; i++ ) {
         if ( aut_acc_ctr > MAX2_COUNTEREXAMPLES ) { break; }
	 if ( ! ip_mem(i) ) continue;
	 if ( IS(VISITED, i) ) continue;
	 en = (ENode *) enodes(i);
	 while ( en ) { 
		EN_non_final_search( en ); 
		en = en->next;
	        if ( all_counterexamples ) continue; 
	        if ( alreadyNO && show_statistics ) {
	             all_time_f = nc_stopclock(all_time);
                     fncomp2 = comp_ctr - 1;
                     fnacc2 = acc_ctr;
	             ShowStatistics();
                     fclose(fres); 
                     if ( no_output ) { EXIT_NO_OUTPUT; }
	             exit(0);}
		}
	 }
   fncomp2 = comp_ctr - 1;
   fnacc2 = acc_ctr;

   fclose(fres);
   if (! alreadyNO ) {
       if (! final_result ) printf("\nYES!\n");
       else printf("\nNO.\n\n** Counterexamples in file %s **\n", result_SCCs);
       }
   else printf("\n** Counterexamples in file %s **\n\n", result_SCCs);
   all_time_f = nc_stopclock(all_time);
   if (show_statistics) ShowStatistics();
   if ( no_output ) { EXIT_NO_OUTPUT; }
   exit(0);
}/*main*/


