/*********************************************/
/* synchron.c                                */
/*                                           */
/* F.Wallner August 98                       */
/*********************************************/

#include "qq_header.h"

TransitionList** b_trans;

/*********************************************************************/
STEdge Find_STEdge(Place p, Cardinal32 num)
{
 	STEdge post = p->postset;

	while (post != (STEdge) NULL) 
	     if (post->trans->numname == num) return(post); 
	     else post = post->nexttrans; 
	return( (STEdge) NULL);
}
/*********************************************************************/
TSEdge Find_TSEdge(Place p, Cardinal32 num)
{
 	TSEdge pre = p->preset;
  
	while (pre != (TSEdge) NULL) 
	     if (pre->trans->numname == num) return(pre); 
	     else pre = pre->nexttrans; 
	return( (TSEdge) NULL);
}
/*********************************************************************/
char is_preset(Place p, Transition t)
{
	TSEdge pre = p->preset;

	while (pre != (TSEdge) NULL)
	      if (pre->trans == t) return(1);
	      else pre = pre->nexttrans;
	return(0);
}
/*********************************************************************/
char is_postset(Place p, Transition t)
{
	STEdge post = p->postset;

	while (post != (STEdge) NULL)
	      if (post->trans == t) return(1);
	      else post = post->nexttrans;
	return(0);
}
/*********************************************************************/
char is_looped(Place p, Transition t)
{
	 return(is_preset(p,t) && is_postset(p,t));
}
/*********************************************************************/
void synchronize(LMPNet net, char **var_names, int size, int pp_num)
/*       net = sync.ll_net
   var_names = observed places
        size = number of observed places
      pp_num = numname of next Place to include   	*/ 
{
	unsigned int   i;
	TransitionList *tlist, *tlptr;
	Transition     dt = (Transition) NULL;
	Place          pl_name, pl_mean, pl, dp = P_NULL;
 	STEdge         st, dst = (STEdge) NULL;
	TSEdge         ts, dts = (TSEdge) NULL;
	char           compl, actual_name[MAXMEANING], meaning[MAXMEANING];
	Cardinal32     p_num = pp_num;
	Coords         co;
        BuechiTrans    *BTr_p;
	Int_List       *newil;

	for (i = 0; i < size; i++) {
	   if ((var_names[i])[0] == '!') 
		{ strcpy(actual_name, &((var_names[i])[1]) ); compl = 1; }
           else { strcpy(actual_name,    var_names[i]      ); compl = 0; }

	   pl = net->Places;
	   pl_mean = pl_name = P_NULL;
	   while (pl != P_NULL) {
	         if ( (GET_PL_MEANING(pl))  && 
	              (strcmp(GET_PL_MEANING(pl), actual_name) == 0) ) {
		       if (pl_mean) WARN_SEV_PL_MEAN( actual_name );
                       pl_mean = pl; }
                 if ( (pl->name) && (strcmp(pl->name, actual_name) == 0)){
		       if ( pl_name ) WARN_SEV_PL_NAME( actual_name );
                       pl_name = pl; }
                 pl = pl->nextplace;
		 }
           if ( (pl_mean == P_NULL) && (pl_name == P_NULL) ) {
	        ERR_NO_PL_MEAN_NAME( actual_name );
                if (initialize_net) MAYBE_ENTRY ;
	        exit (1); }
           if ( pl_mean && pl_name && (pl_mean != pl_name) ) 
                WARN_CONFLICT_PL(pl_name->name, pl_mean->name, actual_name);

           if (pl_mean) pl = pl_mean;  
	   else         pl = pl_name;

	   /*** if (observed-Place has to be marked) ***/
	   if ( ! compl ) {
	      tlptr = b_trans[i];
	      while (tlptr != (TransitionList *) NULL) {
                     BTr_p = BTrans;
		     while (BTr_p != (BuechiTrans *) NULL) {
		            if (BTr_p->trans==c_num(tlptr->t->name)) { break; }
			    else BTr_p = BTr_p->next; }
                     if (BTr_p == (BuechiTrans *) NULL) {
			 ERR_NO_TRANS( tlptr->t->name );
                         exit(1); }
		     newil = NEW_INTLIST;
		     newil->i = i;
		     newil->next = BTr_p->il;
		     BTr_p->il = newil;
		     st = Insert_PT(net, pl, tlptr->t, 1,&dp,&dt,&dst);
		     if ( st ) {
		       co = (Coords) st->weight;
		       if (co && (co = co->next) ) co->y = 4; /*invisible arc*/
		       }
		     ts = Insert_TP(net, pl, tlptr->t, 1,&dp,&dt,&dts);
		     if ( ts ) {
		       co = (Coords) ts->weight;
		       if (co && (co = co->next) ) co->y = 4; /*invisible arc*/
		       }
		     tlptr = tlptr->next;
		     }
	      tlptr = tlist = TPreset(pl);
	      while (tlptr != (TransitionList *) NULL) {
		    st = Insert_PT(net, p_ss, tlptr->t, 1,&dp,&dt,&dst);
		    if ( st ) {
		      co = (Coords) st->weight;
		      if ( co && (co = co->next) ) co->y = 4; /*invisible arc*/
		      }
		    ts = Insert_TP(net, p_sf, tlptr->t, 1,&dp,&dt,&dts);
		    if ( ts ) {
		      co = (Coords) ts->weight;
		      if ( co && (co = co->next) ) co->y = 4; /*invisible arc*/
		      }
		    tlptr = tlptr->next;
		    }
              Free_TList(tlist);
	      tlptr = tlist = TPostset(pl);
	      while (tlptr != (TransitionList *) NULL) {
		    st = Insert_PT(net, p_ss, tlptr->t, 1,&dp,&dt,&dst);
		    if ( st ) {
		      co = (Coords) st->weight;
		      if ( co && (co = co->next) ) co->y = 4; /*invisible arc*/
		      }
		    ts = Insert_TP(net, p_sf, tlptr->t, 1,&dp,&dt,&dts);
		    if ( ts ) {
		      co = (Coords) ts->weight;
		      if ( co && (co = co->next) ) co->y = 4; /*invisible arc*/
		      }
		    tlptr = tlptr->next;
		    }
              Free_TList(tlist);
	      if (GET_PL_MEANING(pl)) { strcpy(meaning, GET_PL_MEANING(pl));
					FREE_PL_MEANING(pl); }
              else meaning[0] = '\0';
	      strcat(meaning, "__OBS(");
              strcat(meaning, var_names[i]);
              strcat(meaning, ")");
	      SET_PL_MEANING(pl, meaning);
	      continue;
	      }

	   /*** ObservedPlace has to be unmarked ***/ 
	   /***   complement_place to search!!   ***/ 
	   pl_name = Complement_Place(pl);
	   if ( pl_name == P_NULL) 
	        pl_name = Create_Complement(&net, var_names[i], ++p_num, pl);

	   if (GET_PL_MEANING(pl_name)) {
	       strcpy(meaning, GET_PL_MEANING(pl_name));
	       FREE_PL_MEANING(pl_name); 
	       }
           else meaning[0] = '\0'; 
	   strcat(meaning, "__OBS(");
           strcat(meaning, var_names[i]);
           strcat(meaning, ")");
	   SET_PL_MEANING(pl_name, meaning);
	   /*if ( (! Post_of_Entry(pl)) && (! Post_of_Entry(pl_name)) )*/
                pl_name->marks = 1 - pl->marks;
	   tlptr = tlist = TPreset(pl_name);
	   while (tlptr) {
		 st = Insert_PT(net, p_ss, tlptr->t, 1,&dp,&dt,&dst);
		 if ( st ) {
		   co = (Coords) st->weight;
		   if ( co && (co = co->next) ) co->y = 4; /*invisible arc*/
		   }
		 ts = Insert_TP(net, p_sf, tlptr->t, 1,&dp,&dt,&dts);
		 if ( ts ) {
		   co = (Coords) ts->weight;
		   if ( co && (co = co->next) ) co->y = 4; /*invisible arc*/
		   }
		 tlptr = tlptr->next;
		 }
           Free_TList(tlist);
	   tlptr = tlist = TPostset(pl_name);
	   while (tlptr) {
		 st = Insert_PT(net, p_ss, tlptr->t, 1,&dp,&dt,&dst);
		 if ( st ) {
		   co = (Coords) st->weight;
		   if ( co && (co = co->next) ) co->y = 4; /*invisible arc*/
		   }
		 ts = Insert_TP(net, p_sf, tlptr->t, 1,&dp,&dt,&dts);
		 if ( ts ) {
		   co = (Coords) ts->weight;
		   if ( co && (co = co->next) ) co->y = 4; /*invisible arc*/
		   }
		 tlptr = tlptr->next;
		 }
           Free_TList(tlist);
	   tlptr = b_trans[i];
	   while (tlptr) {
                 BTr_p = BTrans; 
                 while (BTr_p){ 
		        if (BTr_p->trans == c_num(tlptr->t->name) ) { break;}
		        else BTr_p = BTr_p->next; }
                if ( ! BTr_p) { ERR_NO_TRANS( (tlptr->t->name) ); exit(1);}
		newil = NEW_INTLIST; 
		newil->i = i; 
		newil->next = BTr_p->il; 
		BTr_p->il = newil;
		st = Insert_PT(net, pl_name, tlptr->t, 1,&dp,&dt,&dst);
		if ( st ) {
		  co = (Coords) st->weight;
		  if ( co && (co = co->next) ) co->y = 4; /*invisible arc*/
		  }
		ts = Insert_TP(net, pl_name, tlptr->t, 1,&dp,&dt,&dts);
		if ( ts ) {
		  co = (Coords) ts->weight;
		  if ( co && (co = co->next) ) co->y = 4; /*invisible arc*/
		  }
		tlptr = tlptr->next;
		}
           }
}
/*********************************************************************/
void Synchronize_Net(char *out, char **argv, int argc)
{
/*  out = sync.ll_net  
   argv = propositions in formula   
   argc = number of observed places 	*/

	int i, p_num, tctr, pctr, xposition, yposition, yminpos;
	TransitionList *tlnew;
	char newname[MAXCHAR];
	Place ppp;
	Transition ttt;
	TSEdge tp;

	p_num = spl_num;
	
	b_trans=(TransitionList **) MyMalloc(sizeof(TransitionList *) * argc);
	for (i=0; i < argc; i++) b_trans[i] = TL_NULL;

	ttt = sysnet->Transitions;
	while (ttt) {
              if ( ( myindex(ttt->name,  "_c_T") == 0 ) ) {
                 if ( strcmp(GET_TR_MEANING(ttt), "^[tt]") == 0 ) {
		      ttt=ttt->nexttrans; continue; } 
	         for (i=0; i<argc; i++) {
		     tctr = strlen(argv[i]);
	             if ((pctr=myindex(GET_TR_MEANING(ttt), argv[i])) > 0 ) {
			if ( ( (GET_TR_MEANING(ttt))[pctr-1] != '[' ) &&
			     ( (GET_TR_MEANING(ttt))[pctr-1] != ',' )    )
			     continue;
			if ( ( (GET_TR_MEANING(ttt))[pctr+tctr] != ']' ) &&
			     ( (GET_TR_MEANING(ttt))[pctr+tctr] != ',' )    )
			     continue;
		        tlnew = NEWTLIST; 
		        tlnew->t = ttt;
		        tlnew->next = b_trans[i];
		        b_trans[i] = tlnew; }
                     }
		 }
                 ttt = ttt->nexttrans;
              } /* while(ttt) */

	/*************************************/
	synchronize(sysnet, argv, argc, p_num);
	/*************************************/




	for (i=0; i < argc; i++)  Free_TList(b_trans[i]);
	free(b_trans);

	if (print_aut_as_ll) write_new_PEP(bnet, LLautomaton); 

        /*** repositioning the nodes of the sysnet ***/
        yminpos = INFTY;
        ppp = sysnet->Places;
        while ( ppp ) { yminpos = MIN( yminpos, GET_PL_Y_POS(ppp) );
                        ppp = ppp->nextplace; }
        ttt = sysnet->Transitions;
        while ( ttt ) { yminpos = MIN( yminpos, GET_TR_Y_POS(ttt) );
                        ttt = ttt->nexttrans; }
        if ( yminpos > 50 ) yminpos -= 10; else yminpos = 0;
        ppp = sysnet->Places;
        while ( ppp ) { if ( myindex( ppp->name, "_c_P" ) != 0 ) { 
                             xposition = GET_PL_X_POS( ppp );
                             yposition = GET_PL_Y_POS( ppp );
                             xposition += 250; yposition -= yminpos;
                             SET_PL_X_POS(ppp, xposition); 
                             SET_PL_Y_POS(ppp, yposition); }
                         ppp = ppp->nextplace; }
        ttt = sysnet->Transitions;
        while ( ttt ) { if ( myindex( ttt->name, "_c_T" ) != 0 ) { 
                             xposition = GET_TR_X_POS( ttt );
                             yposition = GET_TR_Y_POS( ttt );
                             xposition += 250; yposition -= yminpos;
                             SET_TR_X_POS(ttt, xposition); 
                             SET_TR_Y_POS(ttt, yposition); }
                        ttt = ttt->nexttrans; }

	/*** Rename the accepting transitions ***/
	ttt = sysnet->Transitions;
	while (ttt) {
	       if ( (ttt->name)[0] == '@') {
		    WARN_RENAME( (&((ttt->name)[1])) );
	            sprintf(newname, "_AT_%s", &((ttt->name)[1]));
	            free(ttt->name);
	            ttt->name = Strdup(newname); }
               ttt = ttt->nexttrans;
	       }
	ppp = sysnet->LastPlace;
	while (ppp) {
	       if ( myindex(ppp->name, "_c_P") == 0) {
		    if ( (GET_PL_MEANING(ppp)) &&
			 (myindex(GET_PL_MEANING(ppp), "accept") >= 0 ) ) {
		        tp = ppp->preset;
		        while (tp) { sprintf(newname,"@%s",tp->trans->name);
				     free(tp->trans->name);
				     tp->trans->name = Strdup(newname);
				     tp = tp->nexttrans; }
                        }
                    }
               ppp = ppp->prevplace;
	       }

	write_new_PEP(sysnet, out);

        ttt = bnet->Transitions;
	while (ttt) { Free_Trans_All(ttt); ttt = ttt->nexttrans; }
	ppp = bnet->Places;
	while (ppp) { Free_Place_All(ppp); ppp = ppp->nextplace; }
        remove_net(&bnet);
        tctr = pctr = 0;
	ttt = sysnet->Transitions;
	while (ttt) { tctr++; Free_Trans_All(ttt); ttt = ttt->nexttrans; }
	ppp = sysnet->Places;
	while (ppp) { pctr++; Free_Place_All(ppp); ppp = ppp->nextplace; }
        remove_net(&sysnet);

	
}
/*********************************************************************/
void Translate_to_Prod(FILE *f, char *prog_name)
{
	
	Transition     tr;
	Place          pl;
 	STEdge         st;
	TSEdge         ts;
	int            i,j,pos;
	char           name[MAXCHAR];

	fprintf(f, "/*  This file was generated by the translation-function\n");
	fprintf(f, "    of the LTL-checker %s  */\n\n", prog_name);

        pl = sysnet->Places;
        while (pl != P_NULL) {
              fprintf(f, "#place ");
	      if (pl->name != (char *) NULL) {
		 if (((pl->name)[0] <= '9') && ((pl->name)[0] >= '0')) 
		       fprintf(f, "P__");
		 fprintf(f, "%s\t", pl->name); }
	      else fprintf(f, "P%d\t", pl->numname);
              fprintf(f, "lo(<.1.>) hi(<.1.>)");
              if (pl->marks) fprintf(f, " mk(<.1.>)");
              fprintf(f, "\n");
              pl = pl->nextplace;
              }
        fprintf(f ,"\n");
        tr = sysnet->Transitions;
 	while (tr != T_NULL) {
	      fprintf(f, "#trans ");
  	      if (tr->name != (char *) NULL ) {
		 if (((tr->name)[0] <= '9') && ((tr->name)[0] >= '0')) 
		       fprintf(f, "T__");
		 fprintf(f, "%s\nin  {\n", tr->name); }
	      else fprintf(f, "T%d\nin  {\n", tr->numname);
              st = tr->preset;
              while ( st != (STEdge) NULL ) {
		      pl = st->place;
		      if (pl->name != (char *) NULL) {
		           if (((pl->name)[0] <= '9')&&((pl->name)[0] >= '0')) 
		                 { fprintf(f, "\tP__");
		                   fprintf(f, "%s: <.d.>;\n", pl->name); }
		           else fprintf(f, "\t%s: <.d.>;\n", pl->name);}
		      else fprintf(f, "\tP%d: <.d.>;\n", pl->numname);
		      st = st->nextplace; }
              fprintf(f, "    }\nout {\n");
              ts = tr->postset;
              while ( ts != (TSEdge) NULL ) {
                      pl = ts->place;
		      if (pl->name != (char *) NULL) {
		           if (((pl->name)[0] <= '9')&&((pl->name)[0] >= '0')) 
				 { fprintf(f, "\tP__");
		                   fprintf(f, "%s: <.d.>;\n", pl->name); }
                           else fprintf(f, "\t%s: <.d.>;\n", pl->name); }
		      else fprintf(f, "\tP%d: <.d.>;\n", pl->numname);
		      ts = ts->nextplace; }
              fprintf(f, "    }\n#endtr\n");
              tr = tr->nexttrans;
              } 

	fprintf(f, "\n%s\n", prod_formel);

	for (i=0; i<observed_places; i++) { 
	     if (propositions[i][0] == '!') {
		 j = 1; pos = 0;
		 while (propositions[i][j] != '\0') 
			name[pos++] = propositions[i][j++];
                 name[pos] = '\0';
		 free(propositions[i]);
		 propositions[i] = Strdup(name);
		 }
             }
		 
	if (observed_places) {
	    pl = sysnet->Places;
	    while (pl) {
		   for (i=0; i<observed_places; i++) {
			if (strcmp(propositions[i], pl->name) == 0 ) {
			    fprintf(f,"prop '%s' place: %s\n", \
				       propositions[i], pl->name);
                            break; }
			if (GET_PL_MEANING(pl) &&
			    strcmp(propositions[i], GET_PL_MEANING(pl)) == 0 ) {
			    fprintf(f,"prop '%s' place: %s\n", \
				       propositions[i], pl->name);
                            break; }
                        }
                    pl = pl->nextplace;
		    }
             }
}
/*********************************************************************/
char Translate_from_Prod(FILE *f, char *prog_name)
{

	Place 		p, dp = P_NULL, pnum;
	Transition 	t, dt = (Transition) NULL, tnum;
	STEdge 		st, dst = (STEdge) NULL;
	TSEdge		ts, dts = (TSEdge) NULL;
 	char 		line[MAXLINE], name[MAXNAME], marked, in_trans, in_out;
       	int		pos,x,idx, p_ctr=1, t_ctr=1;

	sysnet=empty_net();
        in_trans = in_out = 0;
	while (fgetline(f, line, MAXLINE) ) {
               if (in_trans) {
                  if (myindex(line, "in  {") >= 0 ) continue;
                  if (myindex(line, "out {") >= 0 ) { in_out = 1; continue; }
                  if (myindex(line, "    }") >= 0 ) {
                      if (! in_out ) { in_out = 1; continue; }
                      if ( in_out )  { in_out = 0; continue; }
                      }
                  if (myindex(line, "#endtr") >=0 ) {in_trans = 0; continue; }
                  pos = x = 0;
                  if (line[x] == '\t') x++;
                  while (line[x] != ':') name[pos++] = line[x++];
                  name[pos] = '\0' ;
                  p = sysnet->Places;
                  while (p) { if (strcmp(name, p->name) == 0) break; 
                              p = p->nextplace; } 
                  if (p == P_NULL) { ERR_PROD( name ); return(1); }
                  if (in_out) ts = Insert_TP(sysnet,p,t,1,&dp,&dt,&dts);
                  else        st = Insert_PT(sysnet,p,t,1,&dp,&dt,&dst);
                  continue;
                  }
	       if ( (idx=myindex(line, "#place")) >= 0 ) {
                  if (myindex(line, "lo(<.1.>) hi(<.1.>)") < 0 ) {
                     fprintf(stderr, "PROD-Net-ERROR:\n%s\n", line);
                     return(2); }
                  if (myindex(line, "mk(<.1.>)") >= 0 ) marked = 1;
                  else marked = 0;
		  pos = 0; x = idx + 7;
                  while (line[x] != '\t') name[pos++] = line[x++];
                  name[pos] = '\0';
                  p = Insert_Place(sysnet, name, (Cardinal32) marked, &dp);
                  pnum = sysnet->Places; p_ctr=1;
                  while (pnum) {pnum->numname = p_ctr++; pnum=pnum->nextplace;}
                  continue;
	          }
    	       if ( (idx=myindex(line, "#trans")) >= 0 ) {
                  in_trans = 1;
                  pos = 0; x = idx + 7;
                  while (line[x] != '\n') name[pos++] = line[x++];
                  name[pos] = '\0';
                  t = Insert_Transition(sysnet, name, &dt);
                  tnum = sysnet->Transitions; t_ctr=1;
                  while (tnum) { tnum->numname=t_ctr++; tnum=tnum->nexttrans; }
                  continue;
                  }
               }
       	return(0);
}

/*************/
/*synchron.c */
/*************/
