/***********************************/
/* unfolding.h                     */
/* Frank Wallner  Sep. 98, Apr 99  */
/***********************************/

/**************************************************************************/
/* Functions                    */
/********************************/

/* Fundamental Configuration--Cut--Set - Functions */
/***************************************************/
     int  SetCopy(SetS src, SetS cpy);
    void  Configuration(ConfS conf, int e);
    void  ENode_Config(ConfS conf, ENode *enod);
    void  Cut(CutS cut, ConfS conf, int max);
    void  Setminus(SetS c1, SetS c2, SetS c3);
    void  ConfAdd(ConfS conf, int elem, int *max_elem);
    char  Concurrent(int e1, int e2, int *ta, CutS cut);
    char  GConcurrent(ConfS conf, int e1, int e2, int *ta, CutS cut);
     int  CIn_Conflict(ConfS config, ConfS conflict, int border);
     int  In_Conflict_1gt2(int e1, int e2);
     int  In_Conflict_2gt1(int e1, int e2);
     int  NC_In_Conflict_1gt2(int e1, int e2);
     int  NC_In_Conflict_2gt1(int e1, int e2);
     int  NC_In_Conflict(int e1, int e2);
     int  Find_Extension(CutS cut, int transition, int *max); 
    void  Make_Conflict(int e);
Int_List  *TransList(int e1, int e2);
Int_List  *CoTRList(Int_List *cl, ConfS conf, int max);
Int_List  *RevBA2IL(BitArray *ba);
    void  IL2CONF(Int_List *il, ConfS ba, int maxelem);
    void  IL2CUT(Int_List *il, CutS ba, int maxelem);
    char  IL_equal(Int_List *il1, Int_List *il2);
    char  IL_less(Int_List *il1, Int_List *il2);
Int_List  *array2list(int *ta);
Int_List  *array2listTA(int *ta);
Int_List  *array2listTA_minus_c(int *ta, int c);
Int_List  *CopyIntList(Int_List *il);
Int_List  *ReverseCopyIntList(Int_List *il);
Int_List  *Max_Events(ConfS c, int maxe);
    void  Shift(int v, Int_List **tl, ENode **w0ci);
    void  Extend_GC(ENCorr *enco, int v, Int_List **tl, ENode **w0ci);
    void  Extend_LC(int enco, int v, Int_List **tl, ENode **w0ci);
    void  *updateTL(Int_List **tl, int cutoff);

/* Functions for Initializing the Data Structures */
/**************************************************/
       void  InsertPost(int cond, int tnum, int event);
       char  GetEvents(FILE *unf, Event **glob_e, int* B, int* E);	
       void  ReadConflicts(FILE *unf);
       void  Init_Extended_Search();

/* Functions for getting Buechi-Information */
/********************************************/
       char  is_marked(Int_List *il);
       void  Evaluate(ConfS conf);
       void  InstantiateAutomaton();
       void  Initialize_Buechi_Nodes();
       char  *TransName(int i);
       char  *PlaceName(int i);
        int  c_num(char *name);
        int  PlaceCount(LMPNet n);
        int  TransCount(LMPNet n);


/* Functions for manipulating the boolean expressions */
/******************************************************/
   trans_PL  *Copy_TPL(trans_PL *t);
   trans_PL  *create_tree(int op, trans_PL *lop, trans_PL *rop);
   trans_PL  *create_leaf(char *prop);
       void  free_tree(trans_PL *tree);
   trans_PL  *copy_tree(trans_PL *tree);
   trans_PL  *DNF_convert(trans_PL *tree);
   trans_PL  *DNF_negate(trans_PL *tree);
   trans_PL  *DNF_multiply_left(trans_PL *left, trans_PL *right);
   trans_PL  *DNF_multiply_right(trans_PL *left, trans_PL *right);
BuechiTrans  *BTransList(trans_PL *t);
       void  Free_trans_PL(trans_PL *tplp);
       void  Free_BuechiTrans(BuechiTrans* bt);
       void  Free_Int_List(Int_List *ilist);
       void  Free_UC_List(UC_List *ilist);

/********************************/
/* End of File unfolding.h      */
/********************************/

